(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    176282,       4877]
NotebookOptionsPosition[    146133,       4226]
NotebookOutlinePosition[    146547,       4242]
CellTagsIndexPosition[    146504,       4239]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Loding", " ", "the", " ", "Packages"}], " ", "*)"}]], "Input",Expre\
ssionUUID->"f6b859ca-8d89-41f5-8725-3af666c69158"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "SARAH.m"}]], "Input",ExpressionUUID->"e25089f2-9026-432c-bb11-d17747f3a383"],

Cell[CellGroupData[{

Cell[BoxData["\<\"SARAH 3.0.beta2\"\>"], "Print",ExpressionUUID->"1a16dfc9-ba0e-4b1d-982f-f0c204e5f08b"],

Cell[BoxData["\<\"by Florian Staub, 2010\"\>"], "Print",ExpressionUUID->"238ed1ee-6204-4806-bbda-3c377e84dac2"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"948bb090-7de1-4661-852c-6c89b4759c9a"],

Cell[BoxData["\<\"Begin evaluation of Model with:       Start[\\\"Name of \
Model\\\"]\"\>"], "Print",ExpressionUUID->"c675b099-6d5a-44c7-8e10-\
b51bf6b042fa"],

Cell[BoxData["\<\"e.g. Start[\\\"MSSM\\\"] or \
Start[\\\"NMSSM\\\",\\\"CKM\\\"]\"\>"], "Print",ExpressionUUID->"9dbb4209-\
4c8f-4757-a2d6-24b04d34bedb"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", "-"}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Initializing", " ", "the", " ", "Model"}], "   ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", "-"}]}]}]}]}]}]}]}]}]}]}]}], " ", 
   "*)"}]}]], "Input",ExpressionUUID->"540810d7-54c7-44ea-a1fa-1799974bf782"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Start", "[", "\"\<MSSM\>\"", "]"}]], "Input",ExpressionUUID->"ec4f72d7-698a-402c-961e-c8bf7d8166fc"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Initialization\"\>"], "Print",ExpressionUUID->"6a1d683b-79aa-4d23-b027-de865e0673eb"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"e61af75b-ac58-40fb-b042-b9ec828c89d0"],

Cell[BoxData["\<\"Model file for the MSSM loaded\"\>"], "Print",ExpressionUUID->"1c74e509-c417-408c-b0c7-e9d683720979"],

Cell[BoxData["\<\"Generate all Superfields\"\>"], "Print",ExpressionUUID->"fbafbfc8-54d1-43fe-97c8-f51c86ebf7db"],

Cell[BoxData["\<\"Create all component Fields\"\>"], "Print",ExpressionUUID->"7f4ed706-ee4b-49d9-b34f-eab01a83446e"],

Cell[BoxData["\<\"Generate Parameter Dependences\"\>"], "Print",ExpressionUUID->"4c3a76ca-7242-4b28-b5cd-4a59af3290b2"],

Cell[BoxData["\<\"Set Information for Rotations\"\>"], "Print",ExpressionUUID->"227059c0-98d9-48a7-9a11-f49fc5af2c5d"],

Cell[BoxData["\<\"Check Anomalies\"\>"], "Print",ExpressionUUID->"d0d4025a-7362-4a3a-a0ef-2eb242e674af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     No (\"\>", "\[InvisibleSpace]", "hypercharge", 
   "\[InvisibleSpace]", "\<\")^3 Gauge Anomaly\"\>"}],
  SequenceForm["     No (", hypercharge, ")^3 Gauge Anomaly"],
  Editable->False]], "Print",ExpressionUUID->"e0430ead-3b14-42d0-852f-\
c588100bda30"],

Cell[BoxData["\<\"     No Witten Anomaly\"\>"], "Print",ExpressionUUID->"75c7e840-322e-4c6a-9164-d2641565a443"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     No (\"\>", "\[InvisibleSpace]", "hypercharge", 
   "\[InvisibleSpace]", "\<\")x(\"\>", "\[InvisibleSpace]", "left", 
   "\[InvisibleSpace]", "\<\")^2  Gauge Anomaly\"\>"}],
  SequenceForm["     No (", hypercharge, ")x(", left, ")^2  Gauge Anomaly"],
  Editable->False]], "Print",ExpressionUUID->"5c0af10e-89df-4f22-b50a-\
6eca7fc05c86"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     No (\"\>", "\[InvisibleSpace]", "color", 
   "\[InvisibleSpace]", "\<\")^3 Gauge Anomaly\"\>"}],
  SequenceForm["     No (", color, ")^3 Gauge Anomaly"],
  Editable->False]], "Print",ExpressionUUID->"2f3db33b-be76-404b-9f60-\
08f636d554ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     No (\"\>", "\[InvisibleSpace]", "hypercharge", 
   "\[InvisibleSpace]", "\<\")x(\"\>", "\[InvisibleSpace]", "color", 
   "\[InvisibleSpace]", "\<\")^2  Gauge Anomaly\"\>"}],
  SequenceForm["     No (", hypercharge, ")x(", color, ")^2  Gauge Anomaly"],
  Editable->False]], "Print",ExpressionUUID->"0c2beb9a-3ffd-46f7-a8e3-\
438f99545635"],

Cell[BoxData["\<\"Calc Superpotential\"\>"], "Print",ExpressionUUID->"1a6f38c8-dc6d-4a23-833a-c6dab951865d"],

Cell[BoxData["\<\"Checking charge conservation of superpotential\"\>"], \
"Print",ExpressionUUID->"488c49cd-72bd-4fa3-85a8-0f57a14808b3"],

Cell[BoxData["\<\"     No violation of charge conservation in \
superpotential\"\>"], "Print",ExpressionUUID->"3677b296-3bdf-40d9-b2f9-\
40b7530ba4c3"],

Cell[BoxData["\<\"Calc F-Terms\"\>"], "Print",ExpressionUUID->"3ef61ba9-7cc2-42d5-9963-2fe416a0646a"],

Cell[BoxData["\<\"Calc Fermion-Scalar\"\>"], "Print",ExpressionUUID->"0da570e7-fa86-4bd1-a377-e2440bc37437"],

Cell[BoxData["\<\"Calc Soft Breaking\"\>"], "Print",ExpressionUUID->"471085c7-1da7-4df1-9807-9b9130649b91"],

Cell[BoxData["\<\"Calc Kinetic Terms\"\>"], "Print",ExpressionUUID->"4bd72022-af2a-4822-afcd-2a37bbd564a2"],

Cell[BoxData["\<\"Calc D-Terms\"\>"], "Print",ExpressionUUID->"e3bf7b61-ed62-4462-a671-93d8cef3f45f"],

Cell[BoxData["\<\"Calc Gaugino Interactions\"\>"], "Print",ExpressionUUID->"e9121cf1-3f86-4d94-a536-9e2dbf5eab36"],

Cell[BoxData["\<\"Calculate Vector Boson Self Interactions\"\>"], "Print",ExpressionUUID->"21f27b80-8170-4a75-9dae-1e5b0244fcea"],

Cell[BoxData["\<\"Calculate Vector Boson - Gaugino - Interactions\"\>"], \
"Print",ExpressionUUID->"648e1032-4c67-4776-b4ed-2eeb275f47b4"],

Cell[BoxData["\<\"Calc Gauge Transformations\"\>"], "Print",ExpressionUUID->"e5741b2d-c757-4864-bf3c-d1aac3b2b317"],

Cell[BoxData["\<\"Calc Complete Lagrangian\"\>"], "Print",ExpressionUUID->"f3181f2f-0927-461a-a14f-0a352ccc3135"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"9a45eaf1-17c0-41c1-b9a5-2ccc89414136"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"3cb9074a-a5cf-4fd6-992b-b1feb859abd9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Evolve States: \"\>", "\[InvisibleSpace]", "\<\"GaugeES\"\>"}],
  
  SequenceForm["Evolve States: ", "GaugeES"],
  Editable->False]], "Print",ExpressionUUID->"5f697e7c-dcfc-4821-996e-\
29c451246ee0"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"72c57a8f-50ba-46a8-bd73-958ba096b189"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",ExpressionUUID->"e742ee29-8790-4227-a98f-c4bbc4174b54"],

Cell[BoxData["\<\"Calc Ghost Interactions\"\>"], "Print",ExpressionUUID->"ebe6753e-6e3c-44bc-b395-98eabd5334f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save Model Information: \"\>", "\[InvisibleSpace]", "GaugeES"}],
  SequenceForm["Save Model Information: ", GaugeES],
  Editable->False]], "Print",ExpressionUUID->"d7904dc9-ce17-45c9-b9b2-\
3018a6bc757e"],

Cell[BoxData["\<\"      TadpoleEquations\"\>"], "Print",ExpressionUUID->"207c38a3-2faf-424c-ae82-40672783153b"],

Cell[BoxData["\<\"      Interactions\"\>"], "Print",ExpressionUUID->"e339eedd-8153-4381-8092-8f7e63d80c6a"],

Cell[BoxData["\<\"      Split Lagrangian\"\>"], "Print",ExpressionUUID->"812a4e7e-48d3-424e-847e-303290aa16fa"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"3fa708ab-5525-4a71-a50c-4edec33495f9"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"dbb37f0f-3891-40e1-89a0-fc2561d7c134"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Evolve States: \"\>", "\[InvisibleSpace]", "\<\"EWSB\"\>"}],
  SequenceForm["Evolve States: ", "EWSB"],
  Editable->False]], "Print",ExpressionUUID->"228b6118-7ca6-46a0-8dfb-\
e6fed1ac39b9"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"15dd92d1-28ca-4828-8db3-639b197bbe02"],

Cell[BoxData["\<\"Parametrize Higgs Sector\"\>"], "Print",ExpressionUUID->"31441e34-d86e-4b60-8377-e483b125b24d"],

Cell[BoxData["\<\"Calc Mixings Gauge Sector\"\>"], "Print",ExpressionUUID->"bc03840f-ef72-4ef1-b32a-b92356b088ca"],

Cell[BoxData["\<\"Add Phases\"\>"], "Print",ExpressionUUID->"70b9d9b7-f8e0-491a-b06b-b6af15eefbda"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",ExpressionUUID->"b2ca419a-3734-4350-a1a0-39de6159cb1c"],

Cell[BoxData["\<\"Calc Mass Matrices\"\>"], "Print",ExpressionUUID->"355d5daf-706f-4c59-b8f0-a14b5d119c1f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"SdL", ",", "SdR"}], "}"}]}],
  SequenceForm["    For ", {SdL, SdR}],
  Editable->False]], "Print",ExpressionUUID->"7633e33e-8323-47ff-8e98-\
a45a5faba93e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "SvL", "}"}]}],
  SequenceForm["    For ", {SvL}],
  Editable->False]], "Print",ExpressionUUID->"f4ca9184-841a-474f-ba1f-\
a203d8ac2f2a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"SuL", ",", "SuR"}], "}"}]}],
  SequenceForm["    For ", {SuL, SuR}],
  Editable->False]], "Print",ExpressionUUID->"4288d34d-4e54-475e-aabe-\
3c05efb3d847"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"SeL", ",", "SeR"}], "}"}]}],
  SequenceForm["    For ", {SeL, SeR}],
  Editable->False]], "Print",ExpressionUUID->"9f707bb6-823e-4337-9828-\
646ddf64de79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"phid", ",", "phiu"}], "}"}]}],
  SequenceForm["    For ", {phid, phiu}],
  Editable->False]], "Print",ExpressionUUID->"da69a155-1e63-433a-ad29-\
abda356c33ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"sigmad", ",", "sigmau"}], "}"}]}],
  SequenceForm["    For ", {sigmad, sigmau}],
  Editable->False]], "Print",ExpressionUUID->"a52b97f9-68d7-45ca-bd1f-\
bd225d196763"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"SHdm", ",", 
     RowBox[{"conj", "[", "SHup", "]"}]}], "}"}]}],
  SequenceForm["    For ", {SHdm, 
    conj[SHup]}],
  Editable->False]], "Print",ExpressionUUID->"422e45b9-9747-4461-b9d2-\
144bff6279b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"fB", ",", "fW0", ",", "FHd0", ",", "FHu0"}], "}"}]}],
  SequenceForm["    For ", {fB, fW0, FHd0, FHu0}],
  Editable->False]], "Print",ExpressionUUID->"19d7f5b3-7706-4e11-b26f-\
32439278ef39"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"fWm", ",", "FHdm"}], "}"}], "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"fWp", ",", "FHup"}], "}"}]}],
  SequenceForm["    For ", {fWm, FHdm}, {fWp, FHup}],
  Editable->False]], "Print",ExpressionUUID->"cfe42683-4275-4b97-a992-\
d9ff85cf1027"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "FeL", "}"}], "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"conj", "[", "FeR", "]"}], "}"}]}],
  SequenceForm["    For ", {FeL}, {
    conj[FeR]}],
  Editable->False]], "Print",ExpressionUUID->"2b1f8207-4731-42e1-8a0a-\
8c8c8ec38fd5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "FdL", "}"}], "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"conj", "[", "FdR", "]"}], "}"}]}],
  SequenceForm["    For ", {FdL}, {
    conj[FdR]}],
  Editable->False]], "Print",ExpressionUUID->"f1f27ef4-0712-48c5-8d4c-\
a65edb9eb448"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    For \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "FuL", "}"}], "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"conj", "[", "FuR", "]"}], "}"}]}],
  SequenceForm["    For ", {FuL}, {
    conj[FuR]}],
  Editable->False]], "Print",ExpressionUUID->"5108a5e7-ddfe-448e-ac63-\
1085ff2d9b19"],

Cell[BoxData["\<\"Calculate Tadpole Equations\"\>"], "Print",ExpressionUUID->"982b611d-c62b-474f-87d4-c4d9ca64ecef"],

Cell[BoxData["\<\"Calc Ghost Interactions\"\>"], "Print",ExpressionUUID->"f282b04b-4f88-4884-886c-c292bdbc9c52"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save Model Information: \"\>", "\[InvisibleSpace]", "EWSB"}],
  SequenceForm["Save Model Information: ", EWSB],
  Editable->False]], "Print",ExpressionUUID->"d10a0bf3-f8c0-4d65-bd45-\
ebba0cf35fdb"],

Cell[BoxData["\<\"      TadpoleEquations\"\>"], "Print",ExpressionUUID->"7d72be7e-8743-44c1-ba95-9366b6e43c09"],

Cell[BoxData["\<\"      Interactions\"\>"], "Print",ExpressionUUID->"f9e42ee6-982d-44e4-9c36-086ce7765ba8"],

Cell[BoxData["\<\"      Split Lagrangian\"\>"], "Print",ExpressionUUID->"1fc75be6-1272-4bc8-8c36-7daaa307de6f"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"08453245-69ac-44d7-bbf5-91bcb6b63fa2"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"0136e2cc-5d58-47fc-8e0b-08a7d833a26e"],

Cell[BoxData["\<\"Finishing\"\>"], "Print",ExpressionUUID->"5463dbd8-fccb-4802-a62f-b3bf13ace204"],

Cell[BoxData["\<\"-----------------------------------\"\>"], "Print",ExpressionUUID->"de9578d9-257c-45b3-8352-9bfee099b28f"],

Cell[BoxData["\<\"Calculate final Lagrangian\"\>"], "Print",ExpressionUUID->"19101e53-585d-476e-b569-a79ce4a23859"],

Cell[BoxData["\<\"Add Matrix Products\"\>"], "Print",ExpressionUUID->"bd2d521f-c22a-42d7-9aeb-5706b1ca0b66"],

Cell[BoxData["\<\"Checking for massless particles\"\>"], "Print",ExpressionUUID->"7629bbd3-6a05-4a58-884c-6da1290adcc5"],

Cell[BoxData["\<\"Calculating Tree Level Masses\"\>"], "Print",ExpressionUUID->"421afd07-c2e3-4116-bb38-fdfca3a9a65f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     For \"\>", "\[InvisibleSpace]", "GaugeES"}],
  SequenceForm["     For ", GaugeES],
  Editable->False]], "Print",ExpressionUUID->"aca3ab40-f263-485a-b084-\
b7290113f7df"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     For \"\>", "\[InvisibleSpace]", "EWSB"}],
  SequenceForm["     For ", EWSB],
  Editable->False]], "Print",ExpressionUUID->"1e2b5357-9766-4129-bb14-\
5e1c8b90aa7e"],

Cell[BoxData["\<\"Simplify Mass Matrices\"\>"], "Print",ExpressionUUID->"9e1fdd08-f69f-48e9-b805-590326b08405"],

Cell[BoxData["\<\"Checking for Spectrum File\"\>"], "Print",ExpressionUUID->"ad757b3f-69b1-4cd4-a983-8f3ecb7133ff"],

Cell[BoxData["\<\"Reading Parameter Values and Dependences\"\>"], "Print",ExpressionUUID->"9108b1c1-8b52-4570-b376-0c87b52453b0"],

Cell[BoxData["\<\"Calculate Mixing Matrices\"\>"], "Print",ExpressionUUID->"dc9dae8b-12f5-4ed4-8bea-10e7004b5adf"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"8a96bbe8-33b8-42bd-b460-7fcad9dbb228"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All Done... \"\>", "\[InvisibleSpace]", "\<\"MSSM\"\>", 
   "\[InvisibleSpace]", "\<\" is ready!\"\>"}],
  SequenceForm["All Done... ", "MSSM", " is ready!"],
  Editable->False]], "Print",ExpressionUUID->"84cf4add-1efd-4002-83ca-\
5482bf0b93ca"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"MASS", " ", "MATRICES"}], "   ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}]}]], "Input",ExpressionU\
UID->"5aea6363-cc00-46c8-9eba-3066054ecb6c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Mass", " ", "matrix", " ", "for", " ", "the", " ", "down", " ", 
    "Squarks"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"MassMatrixUnexpanded", "[", "Sd", "]"}]}]], "Input",ExpressionUUID-\
>"77b5b1f4-2f12-45fa-b8b0-f4907f7f1116"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "24"]}], " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["vd", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm1", ",", "gn1"}], "]"}]}], "-", 
      RowBox[{
       FractionBox["1", "8"], " ", 
       SuperscriptBox["g2", "2"], " ", 
       SuperscriptBox["vd", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm1", ",", "gn1"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "24"], " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["vu", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm1", ",", "gn1"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "8"], " ", 
       SuperscriptBox["g2", "2"], " ", 
       SuperscriptBox["vu", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm1", ",", "gn1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"mq2", "[", 
        RowBox[{"gm1", ",", "gn1"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SuperscriptBox["vd", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm1", ",", "cn1"}], "]"}], " ", 
       RowBox[{"sum", "[", 
        RowBox[{"j1", ",", "1", ",", "3", ",", 
         RowBox[{
          RowBox[{"conj", "[", 
           RowBox[{"Yd", "[", 
            RowBox[{"j1", ",", "gn1"}], "]"}], "]"}], " ", 
          RowBox[{"Yd", "[", 
           RowBox[{"j1", ",", "gm1"}], "]"}]}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"vu", " ", 
         RowBox[{"conj", "[", "\[Mu]", "]"}], " ", 
         RowBox[{"Delta", "[", 
          RowBox[{"cm1", ",", "cn2"}], "]"}], " ", 
         RowBox[{"Yd", "[", 
          RowBox[{"gn2", ",", "gm1"}], "]"}]}], 
        SqrtBox["2"]]}], "+", 
      FractionBox[
       RowBox[{"vd", " ", 
        RowBox[{"Delta", "[", 
         RowBox[{"cm1", ",", "cn2"}], "]"}], " ", 
        RowBox[{
         RowBox[{"T", "[", "Yd", "]"}], "[", 
         RowBox[{"gn2", ",", "gm1"}], "]"}]}], 
       SqrtBox["2"]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"vu", " ", "\[Mu]", " ", 
         RowBox[{"conj", "[", 
          RowBox[{"Yd", "[", 
           RowBox[{"gm2", ",", "gn1"}], "]"}], "]"}], " ", 
         RowBox[{"Delta", "[", 
          RowBox[{"cm2", ",", "cn1"}], "]"}]}], 
        SqrtBox["2"]]}], "+", 
      FractionBox[
       RowBox[{"vd", " ", 
        RowBox[{"conj", "[", 
         RowBox[{
          RowBox[{"T", "[", "Yd", "]"}], "[", 
          RowBox[{"gm2", ",", "gn1"}], "]"}], "]"}], " ", 
        RowBox[{"Delta", "[", 
         RowBox[{"cm2", ",", "cn1"}], "]"}]}], 
       SqrtBox["2"]]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "12"]}], " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["vd", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm2", ",", "cn2"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm2", ",", "gn2"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "12"], " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["vu", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm2", ",", "cn2"}], "]"}], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"gm2", ",", "gn2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Delta", "[", 
        RowBox[{"cm2", ",", "cn2"}], "]"}], " ", 
       RowBox[{"md2", "[", 
        RowBox[{"gn2", ",", "gm2"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SuperscriptBox["vd", "2"], " ", 
       RowBox[{"Delta", "[", 
        RowBox[{"cm2", ",", "cn2"}], "]"}], " ", 
       RowBox[{"sum", "[", 
        RowBox[{"j1", ",", "1", ",", "3", ",", 
         RowBox[{
          RowBox[{"conj", "[", 
           RowBox[{"Yd", "[", 
            RowBox[{"gm2", ",", "j1"}], "]"}], "]"}], " ", 
          RowBox[{"Yd", "[", 
           RowBox[{"gn2", ",", "j1"}], "]"}]}]}], "]"}]}]}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"64206a1d-3986-4b4d-b06c-a4c44f020834"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Mass", " ", "matrix", " ", "for", " ", "the", " ", "scalar", " ", 
   "Higgs"}], " ", "*)"}]], "Input",ExpressionUUID->"eb3db5be-71af-41c3-afc8-\
09decacef83c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassMatrix", "[", "hh", "]"}]], "Input",ExpressionUUID->"592d3cdf-a85c-4e4d-9a20-91b7306ec345"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"mHd2", "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["g1", "2"], " ", 
        SuperscriptBox["vd", "2"]}], "8"], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["g2", "2"], " ", 
        SuperscriptBox["vd", "2"]}], "8"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["g1", "2"], " ", 
        SuperscriptBox["vu", "2"]}], "8"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["g2", "2"], " ", 
        SuperscriptBox["vu", "2"]}], "8"], "+", 
      RowBox[{"\[Mu]", " ", 
       RowBox[{"conj", "[", "\[Mu]", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox["g1", "2"], " ", "vd", " ", "vu"}], "-", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox["g2", "2"], " ", "vd", " ", "vu"}], "-", 
      FractionBox[
       RowBox[{"B", "[", "\[Mu]", "]"}], "2"], "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"conj", "[", 
        RowBox[{"B", "[", "\[Mu]", "]"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox["g1", "2"], " ", "vd", " ", "vu"}], "-", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox["g2", "2"], " ", "vd", " ", "vu"}], "-", 
      FractionBox[
       RowBox[{"B", "[", "\[Mu]", "]"}], "2"], "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"conj", "[", 
        RowBox[{"B", "[", "\[Mu]", "]"}], "]"}]}]}], ",", 
     RowBox[{"mHu2", "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["g1", "2"], " ", 
        SuperscriptBox["vd", "2"]}], "8"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["g2", "2"], " ", 
        SuperscriptBox["vd", "2"]}], "8"], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["g1", "2"], " ", 
        SuperscriptBox["vu", "2"]}], "8"], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["g2", "2"], " ", 
        SuperscriptBox["vu", "2"]}], "8"], "+", 
      RowBox[{"\[Mu]", " ", 
       RowBox[{"conj", "[", "\[Mu]", "]"}]}]}]}], "}"}]}], "}"}]], "Output",Ex\
pressionUUID->"2d742b92-585d-4a5f-a738-8fbb57aa770a"]
}, Open  ]],

Cell[BoxData[""], "Input",ExpressionUUID->"612a6b6d-8c3c-4f9d-8c4c-55a0fdc5a737"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Neutralino", " ", "mass", " ", "matrix"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MassMatrix", "[", "Chi", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",ExpressionUUID->"7bccd167-37b7-44f9-\
8025-26b5ebbe5c4a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"MassB", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "vd"}], "2"]}], ",", 
     FractionBox[
      RowBox[{"g1", " ", "vu"}], "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "MassWB", ",", 
     FractionBox[
      RowBox[{"g2", " ", "vd"}], "2"], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "vu"}], "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "vd"}], "2"]}], ",", 
     FractionBox[
      RowBox[{"g2", " ", "vd"}], "2"], ",", "0", ",", 
     RowBox[{"-", "\[Mu]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "vu"}], "2"], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "vu"}], "2"]}], ",", 
     RowBox[{"-", "\[Mu]"}], ",", "0"}], "}"}]}], "}"}]], "Output",ExpressionU\
UID->"e529b9f2-8501-4901-914f-b3c456d8793f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "VERTICES", "  ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}]}]], "Input",ExpressionU\
UID->"b16cd9b5-2dc6-47a9-99aa-593fb611260a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Higgs", " ", "-", " ", 
   RowBox[{"Up", " ", "Quark"}], " ", "-", " ", 
   RowBox[{"Up", " ", "Quark"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"e07ad035-fbb5-4c5b-ae17-fed0c7668924"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"bar", "[", "Fu", "]"}], ",", "Fu", ",", "hh"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"c09b307f-fbc3-475e-833b-ee3951ee8123"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bar", "[", 
      RowBox[{"Fu", "[", 
       RowBox[{"{", 
        RowBox[{"gt1", ",", "ct1"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"Fu", "[", 
      RowBox[{"{", 
       RowBox[{"gt2", ",", "ct2"}], "}"}], "]"}], ",", 
     RowBox[{"hh", "[", 
      RowBox[{"{", "gt3", "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        SqrtBox["2"]], 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Delta", "[", 
         RowBox[{"ct1", ",", "ct2"}], "]"}], " ", 
        RowBox[{"sum", "[", 
         RowBox[{"j2", ",", "1", ",", "3", ",", 
          RowBox[{
           RowBox[{"conj", "[", 
            RowBox[{"ZUL", "[", 
             RowBox[{"gt2", ",", "j2"}], "]"}], "]"}], " ", 
           RowBox[{"sum", "[", 
            RowBox[{"j1", ",", "1", ",", "3", ",", 
             RowBox[{
              RowBox[{"conj", "[", 
               RowBox[{"ZUR", "[", 
                RowBox[{"gt1", ",", "j1"}], "]"}], "]"}], " ", 
              RowBox[{"Yu", "[", 
               RowBox[{"j1", ",", "j2"}], "]"}]}]}], "]"}]}]}], "]"}], " ", 
        RowBox[{"ZH", "[", 
         RowBox[{"gt3", ",", "2"}], "]"}]}]}]}], ",", "PL"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        SqrtBox["2"]], 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Delta", "[", 
         RowBox[{"ct1", ",", "ct2"}], "]"}], " ", 
        RowBox[{"sum", "[", 
         RowBox[{"j2", ",", "1", ",", "3", ",", 
          RowBox[{
           RowBox[{"sum", "[", 
            RowBox[{"j1", ",", "1", ",", "3", ",", 
             RowBox[{
              RowBox[{"conj", "[", 
               RowBox[{"Yu", "[", 
                RowBox[{"j1", ",", "j2"}], "]"}], "]"}], " ", 
              RowBox[{"ZUR", "[", 
               RowBox[{"gt2", ",", "j1"}], "]"}]}]}], "]"}], " ", 
           RowBox[{"ZUL", "[", 
            RowBox[{"gt1", ",", "j2"}], "]"}]}]}], "]"}], " ", 
        RowBox[{"ZH", "[", 
         RowBox[{"gt3", ",", "2"}], "]"}]}]}]}], ",", "PR"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"ec8aa054-2a55-4338-9ff8-c2dd43f584e4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Gluino", " ", "-", " ", 
   RowBox[{"Down", " ", "Quark"}], " ", "-", " ", 
   RowBox[{"Down", " ", "Squark"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"897541a7-9f1a-4593-9138-d2beee61e162"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"bar", "[", "Fd", "]"}], ",", "Glu", ",", "Sd"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"8821728f-5f6a-4f79-885a-3a7db1e0113a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bar", "[", 
      RowBox[{"Fd", "[", 
       RowBox[{"{", 
        RowBox[{"gt1", ",", "ct1"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"Glu", "[", 
      RowBox[{"{", "gt2", "}"}], "]"}], ",", 
     RowBox[{"Sd", "[", 
      RowBox[{"{", 
       RowBox[{"gt3", ",", "ct3"}], "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "g3", " ", "PhaseGlu", " ", 
       RowBox[{"Lam", "[", 
        RowBox[{"gt2", ",", "ct1", ",", "ct3"}], "]"}], " ", 
       RowBox[{"sum", "[", 
        RowBox[{"j1", ",", "1", ",", "3", ",", 
         RowBox[{
          RowBox[{"conj", "[", 
           RowBox[{"ZD", "[", 
            RowBox[{"gt3", ",", 
             RowBox[{"3", "+", "j1"}]}], "]"}], "]"}], " ", 
          RowBox[{"conj", "[", 
           RowBox[{"ZDR", "[", 
            RowBox[{"gt1", ",", "j1"}], "]"}], "]"}]}]}], "]"}]}], 
      SqrtBox["2"]], ",", "PL"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "g3", " ", 
        RowBox[{"conj", "[", "PhaseGlu", "]"}], " ", 
        RowBox[{"Lam", "[", 
         RowBox[{"gt2", ",", "ct1", ",", "ct3"}], "]"}], " ", 
        RowBox[{"sum", "[", 
         RowBox[{"j1", ",", "1", ",", "3", ",", 
          RowBox[{
           RowBox[{"conj", "[", 
            RowBox[{"ZD", "[", 
             RowBox[{"gt3", ",", "j1"}], "]"}], "]"}], " ", 
           RowBox[{"ZDL", "[", 
            RowBox[{"gt1", ",", "j1"}], "]"}]}]}], "]"}]}], 
       SqrtBox["2"]]}], ",", "PR"}], "}"}]}], "}"}]], "Output",ExpressionUUID-\
>"1be1edb8-6731-4abf-aa86-7d6cda99f91c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "W", "-", "Boson", " ", "-", " ", "W", "-", "Boson", " ", "-", " ", "Z", 
   "-", "Boson"}], " ", "*)"}]], "Input",ExpressionUUID->"3a649b19-d5d5-4c2b-\
9802-8d83d6a2e18c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{"{", 
   RowBox[{"VWm", ",", 
    RowBox[{"conj", "[", "VWm", "]"}], ",", "VZ"}], "}"}], "]"}]], "Input",Exp\
ressionUUID->"5f5cf40c-a501-4376-aa75-51ea0424e6ab"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"VWm", "[", 
      RowBox[{"{", "lt1", "}"}], "]"}], ",", 
     RowBox[{"conj", "[", 
      RowBox[{"VWm", "[", 
       RowBox[{"{", "lt2", "}"}], "]"}], "]"}], ",", 
     RowBox[{"VZ", "[", 
      RowBox[{"{", "lt3", "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", "g2", " ", 
      RowBox[{"Cos", "[", "ThetaW", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"g", "[", 
         RowBox[{"lt1", ",", "lt2"}], "]"}]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Mom", "[", 
           RowBox[{
            RowBox[{"conj", "[", 
             RowBox[{"VWm", "[", 
              RowBox[{"{", "lt2", "}"}], "]"}], "]"}], ",", "lt3"}], "]"}]}], 
         "+", 
         RowBox[{"Mom", "[", 
          RowBox[{
           RowBox[{"VWm", "[", 
            RowBox[{"{", "lt1", "}"}], "]"}], ",", "lt3"}], "]"}]}], ")"}]}], 
      "-", 
      RowBox[{
       RowBox[{"g", "[", 
        RowBox[{"lt2", ",", "lt3"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Mom", "[", 
          RowBox[{
           RowBox[{"conj", "[", 
            RowBox[{"VWm", "[", 
             RowBox[{"{", "lt2", "}"}], "]"}], "]"}], ",", "lt1"}], "]"}], 
         "-", 
         RowBox[{"Mom", "[", 
          RowBox[{
           RowBox[{"VZ", "[", 
            RowBox[{"{", "lt3", "}"}], "]"}], ",", "lt1"}], "]"}]}], ")"}]}], 
      "-", 
      RowBox[{
       RowBox[{"g", "[", 
        RowBox[{"lt1", ",", "lt3"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Mom", "[", 
           RowBox[{
            RowBox[{"VWm", "[", 
             RowBox[{"{", "lt1", "}"}], "]"}], ",", "lt2"}], "]"}]}], "+", 
         RowBox[{"Mom", "[", 
          RowBox[{
           RowBox[{"VZ", "[", 
            RowBox[{"{", "lt3", "}"}], "]"}], ",", "lt2"}], "]"}]}], 
        ")"}]}]}]}], "}"}]}], "}"}]], "Output",ExpressionUUID->"01f6a41d-389a-\
4b80-b36d-2fd9eb357cb0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"4", " ", "Higgs"}], " ", "*)"}]], "Input",ExpressionUUID->\
"2cf72844-d2b5-4543-b664-435540385845"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{"{", 
   RowBox[{"hh", ",", "hh", ",", "hh", ",", "hh"}], "}"}], "]"}]], "Input",Exp\
ressionUUID->"9cb5cf59-ff49-4720-9e89-c8cb0115469c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"hh", "[", 
      RowBox[{"{", "gt1", "}"}], "]"}], ",", 
     RowBox[{"hh", "[", 
      RowBox[{"{", "gt2", "}"}], "]"}], ",", 
     RowBox[{"hh", "[", 
      RowBox[{"{", "gt3", "}"}], "]"}], ",", 
     RowBox[{"hh", "[", 
      RowBox[{"{", "gt4", "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "+", 
        SuperscriptBox["g2", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ZH", "[", 
          RowBox[{"gt1", ",", "2"}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"ZH", "[", 
             RowBox[{"gt2", ",", "1"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "2"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "1"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "1"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "2"}], "]"}]}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"ZH", "[", 
             RowBox[{"gt2", ",", "2"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "1"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "1"}], "]"}]}], "-", 
              RowBox[{"3", " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "2"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"ZH", "[", 
          RowBox[{"gt1", ",", "1"}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"ZH", "[", 
             RowBox[{"gt2", ",", "2"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "2"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "1"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "1"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "2"}], "]"}]}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"ZH", "[", 
             RowBox[{"gt2", ",", "1"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "3"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "1"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "1"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"ZH", "[", 
                RowBox[{"gt3", ",", "2"}], "]"}], " ", 
               RowBox[{"ZH", "[", 
                RowBox[{"gt4", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}]}], 
       ")"}]}], ",", "1"}], "}"}]}], "}"}]], "Output",ExpressionUUID->\
"521d50ca-f62d-4dc0-9c50-6df3690cd6ce"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Gauge", " ", 
   RowBox[{"Eigenstates", ":", " ", 
    RowBox[{
     RowBox[{"Down", " ", "Left", " ", "Squark"}], " ", "-", " ", 
     RowBox[{"Down", " ", "Left", " ", "Squark"}], " ", "-", " ", "B", "-", 
     "Boson"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->"07284f2e-9a1a-4528-\
8a05-2ea797362042"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"conj", "[", "SdL", "]"}], ",", "SdL", ",", "VB"}], "}"}], ",", 
   " ", 
   RowBox[{"Eigenstates", "\[Rule]", "GaugeES"}]}], "]"}]], "Input",Expression\
UUID->"14fb7edf-718b-4cac-873f-382a9f68530e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"conj", "[", 
      RowBox[{"SdL", "[", 
       RowBox[{"{", 
        RowBox[{"gt1", ",", "ct1"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"SdL", "[", 
      RowBox[{"{", 
       RowBox[{"gt2", ",", "ct2"}], "}"}], "]"}], ",", 
     RowBox[{"VB", "[", 
      RowBox[{"{", "lt3", "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", "6"], " ", "\[ImaginaryI]", " ", "g1", " ", 
      RowBox[{"Delta", "[", 
       RowBox[{"ct1", ",", "ct2"}], "]"}], " ", 
      RowBox[{"Delta", "[", 
       RowBox[{"gt1", ",", "gt2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Mom", "[", 
       RowBox[{
        RowBox[{"conj", "[", 
         RowBox[{"SdL", "[", 
          RowBox[{"{", 
           RowBox[{"gt1", ",", "ct1"}], "}"}], "]"}], "]"}], ",", "lt3"}], 
       "]"}], "-", 
      RowBox[{"Mom", "[", 
       RowBox[{
        RowBox[{"SdL", "[", 
         RowBox[{"{", 
          RowBox[{"gt2", ",", "ct2"}], "}"}], "]"}], ",", "lt3"}], "]"}]}]}], 
    "}"}]}], "}"}]], "Output",ExpressionUUID->"88218c82-c4dc-4da2-8847-\
22279bd18162"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Using", " ", "dependences", " ", "of", " ", "parameters"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"b2e488cb-0424-4132-b2d1-84355b457af6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vertex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bar", "[", "Fe", "]"}], ",", "Fe", ",", "VP"}], "}"}], ",", 
   RowBox[{"UseDependences", "\[Rule]", "True"}]}], "]"}]], "Input",Expression\
UUID->"e34ead6a-f27e-4639-b83a-09659bae1945"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bar", "[", 
      RowBox[{"Fe", "[", 
       RowBox[{"{", "gt1", "}"}], "]"}], "]"}], ",", 
     RowBox[{"Fe", "[", 
      RowBox[{"{", "gt2", "}"}], "]"}], ",", 
     RowBox[{"VP", "[", 
      RowBox[{"{", "lt3", "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", "ee", " ", 
      RowBox[{"Delta", "[", 
       RowBox[{"gt1", ",", "gt2"}], "]"}]}], ",", 
     RowBox[{"LorentzProduct", "[", 
      RowBox[{
       RowBox[{"gamma", "[", "lt3", "]"}], ",", "PL"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", "ee", " ", 
      RowBox[{"Delta", "[", 
       RowBox[{"gt1", ",", "gt2"}], "]"}]}], ",", 
     RowBox[{"LorentzProduct", "[", 
      RowBox[{
       RowBox[{"gamma", "[", "lt3", "]"}], ",", "PR"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"5ff86530-9ea4-4894-b119-3f024eb70b2a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"RENORMALIZATION", " ", "GROUP", " ", "EQUAIONS"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}]], "Input",ExpressionUUID->"cf6c1235-34d1-40a4-b37f-\
f32f2945707b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalcRGEs", "[", "]"}]], "Input",ExpressionUUID->"b635d0fc-9a09-48e7-a76a-6a8e0ab36734"],

Cell[CellGroupData[{

Cell[BoxData["\<\"-----------------------\"\>"], "Print",ExpressionUUID->"6aa4314e-3181-4d60-a124-0c1dc0690585"],

Cell[BoxData["\<\"Calculate RGEs   \"\>"], "Print",ExpressionUUID->"793101d6-769d-4c1e-8188-b3b440399639"],

Cell[BoxData["\<\"-----------------------\"\>"], "Print",ExpressionUUID->"d9661af2-2ce3-46f6-8059-b6f39fd0aff2"],

Cell[BoxData["\<\"Making Lists of Particles and Couplings\"\>"], "Print",ExpressionUUID->"685a62d2-1ff2-45fa-9929-d5654d8e1565"],

Cell[BoxData["\<\"Calculating anomalous Dimensions\"\>"], "Print",ExpressionUUID->"6f9d7153-981c-45e1-b2b8-a19f9e0c6eb0"],

Cell[BoxData["\<\"Calculating Beta Functions for Trilinear Parameters of \
Superpotential\"\>"], "Print",ExpressionUUID->"3a59211a-de4f-4852-a770-\
f5d2b8f91df2"],

Cell[BoxData["\<\"Calculating Beta Functions for Bilinear Parameters of \
Superpotential\"\>"], "Print",ExpressionUUID->"f02ff1f2-2f33-4d74-813b-\
1b0fe22d3d6c"],

Cell[BoxData["\<\"Calculating Beta Functions for Tadpole Parameters of \
Superpotential\"\>"], "Print",ExpressionUUID->"f93e0b30-d45a-4bb5-82a4-\
4856d6766844"],

Cell[BoxData["\<\"Calculating Beta Functions for Trilinear Soft Breaking \
Parameters\"\>"], "Print",ExpressionUUID->"6d2b3a28-97b7-4d3f-8bbd-\
76cf9d3a29a2"],

Cell[BoxData["\<\"Calculating Beta Functions for Bilinear Soft Breaking \
Parameters\"\>"], "Print",ExpressionUUID->"77bb77b8-2694-47e4-875e-\
70107ce1aace"],

Cell[BoxData["\<\"Calculating Beta Functions for linear Soft Breaking \
Parameters\"\>"], "Print",ExpressionUUID->"644e7f0c-43ba-4f31-a4f2-\
e2e53cc1154b"],

Cell[BoxData["\<\"Calculating Beta Functions for Scalar Masses\"\>"], "Print",ExpressionUUID->"c212a9a4-b622-4cb9-937c-0cd1c1bfc0e0"],

Cell[BoxData["\<\"Calculating Beta Functions for Gaugino Masses\"\>"], "Print",ExpressionUUID->"275dbb11-31ae-4131-9feb-5e039404436b"],

Cell[BoxData["\<\"Calculating Beta Functions for Gauge Couplings\"\>"], \
"Print",ExpressionUUID->"4f3d11a4-4893-4fca-93ae-b027eb9f1b37"],

Cell[BoxData["\<\"Calculating Beta Functions for four point Parameters of \
Superpotential\"\>"], "Print",ExpressionUUID->"4ef1d4d2-4835-417d-a628-\
ee1535dab730"],

Cell[BoxData["\<\"Calculating Beta Functions for VEVs\"\>"], "Print",ExpressionUUID->"c5be9209-06fd-40e2-92a5-3522bb37f42f"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Up", " ", "-", " ", 
   RowBox[{"Yukawa", " ", "Coupling"}]}], " ", "*)"}]], "Input",ExpressionUUID\
->"09db5274-0925-43b4-bb29-cf49038092f8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaYijk", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}]], "Input",ExpressionUUID->"2a4f2696-\
b5a6-4312-acd7-25adc282c627"],

Cell[BoxData[
 RowBox[{"Yu", "[", 
  RowBox[{"i1", ",", "i2"}], "]"}]], "Output",ExpressionUUID->"c547f455-c397-\
4f96-a51c-19e35930a88b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaYijk", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2"}], "]"}], "]"}]], "Input",ExpressionUUID->"dae49bc4-\
4d97-44f6-a3cd-d60f53a0f541"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "15"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"13", " ", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"45", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"80", " ", 
      SuperscriptBox["g3", "2"]}], "-", 
     RowBox[{"45", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}], " ", 
   RowBox[{"Yu", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"MatMul", "[", 
    RowBox[{"Yu", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd"}], "]"}], "[", 
   RowBox[{"i1", ",", "i2"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}]}]], "Output",ExpressionUUID->"23a74f57-\
f3f4-4ead-bb6d-cc6566efadd4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaYijk", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "3"}], "]"}], "]"}]], "Input",ExpressionUUID->"2126f631-\
bc44-4772-8f26-17e659900f3b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2743", " ", 
       SuperscriptBox["g1", "4"]}], "450"], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     FractionBox[
      RowBox[{"15", " ", 
       SuperscriptBox["g2", "4"]}], "2"], "+", 
     FractionBox[
      RowBox[{"136", " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["g3", "2"]}], "45"], "+", 
     RowBox[{"8", " ", 
      SuperscriptBox["g2", "2"], " ", 
      SuperscriptBox["g3", "2"]}], "-", 
     FractionBox[
      RowBox[{"16", " ", 
       SuperscriptBox["g3", "4"]}], "9"], "+", 
     RowBox[{
      FractionBox["4", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "+", 
        RowBox[{"20", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"9", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}], " ", 
   RowBox[{"Yu", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["g1", "2"]}], "5"], "-", 
     RowBox[{"3", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"trace", "[", 
      RowBox[{"Ye", ",", 
       RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], ")"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["2", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yu", ",", 
     RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}]}]], "Output",ExpressionUUID->"51d46834-\
4ffe-48e8-a444-f90ddcc065be"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Higgs", " ", "Mixing", " ", "Parameter"}], " ", "*)"}]], "Input",Ex\
pressionUUID->"0eb744cc-2942-4d2b-bb79-5ff1ff1a22e9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaBij", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}]], "Input",ExpressionUUID->"9a756fb6-\
5b4f-4398-b024-1d545c98bbc7"],

Cell[BoxData[
 RowBox[{"B", "[", "\[Mu]", "]"}]], "Output",ExpressionUUID->"1fc186ac-cddd-4757-ba4f-844fc32ec532"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaBij", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2"}], "]"}], "]"}]], "Input",ExpressionUUID->"98f767e4-\
00e8-4b52-a9f2-32eae1da3bb3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["6", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", "MassB", " ", "\[Mu]"}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g2", "2"], " ", "MassWB", " ", "\[Mu]"}], "+", 
  RowBox[{
   RowBox[{"B", "[", "\[Mu]", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["g1", "2"]}], "5"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
     RowBox[{"trace", "[", 
      RowBox[{"Ye", ",", 
       RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"6", " ", "\[Mu]", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"Adj", "[", "Yd", "]"}], ",", 
     RowBox[{"T", "[", "Yd", "]"}]}], "]"}]}], "+", 
  RowBox[{"2", " ", "\[Mu]", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"Adj", "[", "Ye", "]"}], ",", 
     RowBox[{"T", "[", "Ye", "]"}]}], "]"}]}], "+", 
  RowBox[{"6", " ", "\[Mu]", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"Adj", "[", "Yu", "]"}], ",", 
     RowBox[{"T", "[", "Yu", "]"}]}], "]"}]}]}]], "Output",ExpressionUUID->\
"d657844e-e223-4592-b6ef-6d53726a139f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaBij", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "3"}], "]"}], "]"}]], "Input",ExpressionUUID->"7bcf429d-\
1e86-4930-97cb-0fb7724fda44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"B", "[", "\[Mu]", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"207", " ", 
       SuperscriptBox["g1", "4"]}], "50"], "+", 
     FractionBox[
      RowBox[{"9", " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["g2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"15", " ", 
       SuperscriptBox["g2", "4"]}], "2"], "-", 
     RowBox[{
      FractionBox["2", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "-", 
        RowBox[{"40", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["6", "5"], " ", 
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Ye", ",", 
        RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "5"], " ", 
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "+", 
     RowBox[{"16", " ", 
      SuperscriptBox["g3", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "-", 
     RowBox[{"9", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"6", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Ye", ",", 
        RowBox[{"Adj", "[", "Ye", "]"}], ",", "Ye", ",", 
        RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "-", 
     RowBox[{"9", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["2", "25"], " ", "\[Mu]", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"207", " ", 
      SuperscriptBox["g1", "4"], " ", "MassB"}], "+", 
     RowBox[{"45", " ", 
      SuperscriptBox["g1", "2"], " ", 
      SuperscriptBox["g2", "2"], " ", "MassB"}], "+", 
     RowBox[{"45", " ", 
      SuperscriptBox["g1", "2"], " ", 
      SuperscriptBox["g2", "2"], " ", "MassWB"}], "+", 
     RowBox[{"375", " ", 
      SuperscriptBox["g2", "4"], " ", "MassWB"}], "-", 
     RowBox[{"10", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["g1", "2"], " ", "MassB"}], "-", 
        RowBox[{"40", " ", 
         SuperscriptBox["g3", "2"], " ", "MassG"}]}], ")"}], " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
     RowBox[{"30", " ", 
      SuperscriptBox["g1", "2"], " ", "MassB", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Ye", ",", 
        RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "+", 
     RowBox[{"20", " ", 
      SuperscriptBox["g1", "2"], " ", "MassB", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "+", 
     RowBox[{"400", " ", 
      SuperscriptBox["g3", "2"], " ", "MassG", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "+", 
     RowBox[{"10", " ", 
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{
        RowBox[{"Adj", "[", "Yd", "]"}], ",", 
        RowBox[{"T", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"400", " ", 
      SuperscriptBox["g3", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{
        RowBox[{"Adj", "[", "Yd", "]"}], ",", 
        RowBox[{"T", "[", "Yd", "]"}]}], "]"}]}], "-", 
     RowBox[{"30", " ", 
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{
        RowBox[{"Adj", "[", "Ye", "]"}], ",", 
        RowBox[{"T", "[", "Ye", "]"}]}], "]"}]}], "-", 
     RowBox[{"20", " ", 
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{
        RowBox[{"Adj", "[", "Yu", "]"}], ",", 
        RowBox[{"T", "[", "Yu", "]"}]}], "]"}]}], "-", 
     RowBox[{"400", " ", 
      SuperscriptBox["g3", "2"], " ", 
      RowBox[{"trace", "[", 
       RowBox[{
        RowBox[{"Adj", "[", "Yu", "]"}], ",", 
        RowBox[{"T", "[", "Yu", "]"}]}], "]"}]}], "+", 
     RowBox[{"450", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}], ",", 
        RowBox[{"T", "[", "Yd", "]"}], ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
     RowBox[{"150", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yd", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", 
        RowBox[{"T", "[", "Yu", "]"}], ",", 
        RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
     RowBox[{"150", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Ye", ",", 
        RowBox[{"Adj", "[", "Ye", "]"}], ",", 
        RowBox[{"T", "[", "Ye", "]"}], ",", 
        RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "+", 
     RowBox[{"150", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yd", "]"}], ",", 
        RowBox[{"T", "[", "Yd", "]"}], ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "+", 
     RowBox[{"450", " ", 
      RowBox[{"trace", "[", 
       RowBox[{"Yu", ",", 
        RowBox[{"Adj", "[", "Yu", "]"}], ",", 
        RowBox[{"T", "[", "Yu", "]"}], ",", 
        RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}]}]}]], "Output",Exp\
ressionUUID->"641cc08b-5af7-4c7a-bfc1-3fa67f8cfba4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"U", 
   RowBox[{"(", "1", ")"}], " ", "Gauge", " ", "Coupling"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"a9ddff40-8988-4500-b17b-95fb174f0fbd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaGauge", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}]], "Input",ExpressionUUID->"17a49d8b-\
9cb7-4183-bb9f-0bf69c99f5f1"],

Cell[BoxData["g1"], "Output",ExpressionUUID->"a3423cdb-8152-44c1-abf4-2d76b879abc7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaGauge", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2"}], "]"}], "]"}]], "Input",ExpressionUUID->"ecfcc68d-\
48da-45d8-95a0-313318ed0b73"],

Cell[BoxData[
 FractionBox[
  RowBox[{"33", " ", 
   SuperscriptBox["g1", "3"]}], "5"]], "Output",ExpressionUUID->"51491a89-\
9158-4a8f-87e4-d80d007fd783"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BetaGauge", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "3"}], "]"}], "]"}]], "Input",ExpressionUUID->"9eeace44-\
b0d4-48c9-a3bb-aabfb1aad06d"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "25"], " ", 
  SuperscriptBox["g1", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"199", " ", 
     SuperscriptBox["g1", "2"]}], "+", 
    RowBox[{"135", " ", 
     SuperscriptBox["g2", "2"]}], "+", 
    RowBox[{"440", " ", 
     SuperscriptBox["g3", "2"]}], "-", 
    RowBox[{"70", " ", 
     RowBox[{"trace", "[", 
      RowBox[{"Yd", ",", 
       RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
    RowBox[{"90", " ", 
     RowBox[{"trace", "[", 
      RowBox[{"Ye", ",", 
       RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "-", 
    RowBox[{"130", " ", 
     RowBox[{"trace", "[", 
      RowBox[{"Yu", ",", 
       RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}]}]], "Output",Expres\
sionUUID->"b4e62d67-bd0d-437d-8977-f82c979ea021"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Down", " ", "-", " ", "Softbreaking", " ", "-", " ", "Mass"}], " ",
   "*)"}]], "Input",ExpressionUUID->"ba5e4f76-7e7c-40f6-926a-8350f6373c66"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Betam2ij", "[", 
  RowBox[{"[", 
   RowBox[{"5", ",", "1"}], "]"}], "]"}]], "Input",ExpressionUUID->"415c834a-\
66d1-4452-ba36-a688993a8de4"],

Cell[BoxData[
 RowBox[{"md2", "[", 
  RowBox[{"i1", ",", "i2"}], "]"}]], "Output",ExpressionUUID->"24975d8d-27f1-\
4ce8-91f4-36986dbbfd84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Betam2ij", "[", 
  RowBox[{"[", 
   RowBox[{"5", ",", "2"}], "]"}], "]"}]], "Input",ExpressionUUID->"8627dede-\
48b1-4919-b443-2e5b655ecfec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["8", "15"]}], " ", 
   SuperscriptBox["g1", "2"], " ", "MassB", " ", 
   RowBox[{"conj", "[", "MassB", "]"}], " ", 
   RowBox[{"Kronecker", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "16"}], " ", 
      SuperscriptBox["g3", "2"], " ", "MassG", " ", 
      RowBox[{"conj", "[", "MassG", "]"}], " ", 
      RowBox[{"Kronecker", "[", 
       RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"Kronecker", "[", 
       RowBox[{"i1", ",", "i2"}], "]"}], " ", 
      RowBox[{"Tr1", "[", "1", "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "mHd2", " ", 
         RowBox[{
          RowBox[{"MatMul", "[", 
           RowBox[{"Yd", ",", 
            RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
          RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{
          RowBox[{"MatMul", "[", 
           RowBox[{
            RowBox[{"T", "[", "Yd", "]"}], ",", 
            RowBox[{"Adj", "[", 
             RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"MatMul", "[", 
          RowBox[{"md2", ",", "Yd", ",", 
           RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
         RowBox[{"i1", ",", "i2"}], "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{
          RowBox[{"MatMul", "[", 
           RowBox[{"Yd", ",", "mq2", ",", 
            RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
          RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"MatMul", "[", 
          RowBox[{"Yd", ",", 
           RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
         RowBox[{"i1", ",", "i2"}], "]"}]}], ")"}]}]}], ")"}]}]}]], "Output",ExpressionUUID->"1f36f525-ee4c-4fa1-96c0-e45475320017"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Betam2ij", "[", 
  RowBox[{"[", 
   RowBox[{"5", ",", "3"}], "]"}], "]"}]], "Input",ExpressionUUID->"b122da15-\
aa7f-4b8b-88d1-2c9e2efa6acc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["64", "45"], " ", 
   SuperscriptBox["g3", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "30"}], " ", 
      SuperscriptBox["g3", "2"], " ", "MassG"}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"MassB", "+", 
        RowBox[{"2", " ", "MassG"}]}], ")"}]}]}], ")"}], " ", 
   RowBox[{"conj", "[", "MassG", "]"}], " ", 
   RowBox[{"Kronecker", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["8", "15"], " ", 
   SuperscriptBox["g1", "4"], " ", 
   RowBox[{"Kronecker", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}], " ", 
   RowBox[{"Tr2", "[", "1", "]"}]}], "+", 
  RowBox[{
   FractionBox["32", "3"], " ", 
   SuperscriptBox["g3", "4"], " ", 
   RowBox[{"Kronecker", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}], " ", 
   RowBox[{"Tr2", "[", "3", "]"}]}], "+", 
  RowBox[{
   FractionBox["8", "3"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{"Kronecker", "[", 
    RowBox[{"i1", ",", "i2"}], "]"}], " ", 
   RowBox[{"Tr3", "[", "1", "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", "mHd2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g2", "2"], " ", "mHd2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"24", " ", 
   SuperscriptBox["g2", "2"], " ", "MassWB", " ", 
   RowBox[{"conj", "[", "MassWB", "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"24", " ", "mHd2", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"8", " ", "mHd2", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"conj", "[", 
      RowBox[{"T", "[", "Yd", "]"}], "]"}], ",", 
     RowBox[{"Tp", "[", 
      RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"conj", "[", 
      RowBox[{"T", "[", "Ye", "]"}], "]"}], ",", 
     RowBox[{"Tp", "[", 
      RowBox[{"T", "[", "Ye", "]"}], "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"md2", ",", "Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"me2", ",", "Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"ml2", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}], ",", "Ye"}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"mq2", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd"}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{
   FractionBox["4", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", "MassB", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   SuperscriptBox["g2", "2"], " ", "MassWB", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"Adj", "[", "Yd", "]"}], ",", 
     RowBox[{"T", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"Adj", "[", "Ye", "]"}], ",", 
     RowBox[{"T", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "225"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{"conj", "[", "MassB", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"303", " ", 
         SuperscriptBox["g1", "2"], " ", "MassB"}], "+", 
        RowBox[{"40", " ", 
         SuperscriptBox["g3", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "MassB"}], "+", "MassG"}], ")"}]}]}], ")"}], " ", 
      RowBox[{"Kronecker", "[", 
       RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
     RowBox[{"90", " ", "MassB", " ", 
      RowBox[{
       RowBox[{"MatMul", "[", 
        RowBox[{"Yd", ",", 
         RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
       RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
     RowBox[{"45", " ", 
      RowBox[{
       RowBox[{"MatMul", "[", 
        RowBox[{
         RowBox[{"T", "[", "Yd", "]"}], ",", 
         RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
       RowBox[{"i1", ",", "i2"}], "]"}]}]}], ")"}]}], "-", 
  RowBox[{"12", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{"conj", "[", "MassWB", "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"conj", "[", 
      RowBox[{"T", "[", "Yd", "]"}], "]"}], ",", 
     RowBox[{"Tp", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{
     RowBox[{"conj", "[", 
      RowBox[{"T", "[", "Ye", "]"}], "]"}], ",", 
     RowBox[{"Tp", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["2", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["2", "5"], " ", 
   SuperscriptBox["g1", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Yd", ",", 
     RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"trace", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}], " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"8", " ", "mHd2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", 
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", "mHd2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", "mHu2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", 
      RowBox[{"T", "[", "Yu", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}], ",", 
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yu", "]"}], "]"}], ",", 
      RowBox[{"T", "[", "Yu", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yd", "]"}], "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{
      RowBox[{"T", "[", "Yd", "]"}], ",", 
      RowBox[{"Adj", "[", 
       RowBox[{"T", "[", "Yu", "]"}], "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2", ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "mu2", ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", "mq2", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    RowBox[{"MatMul", "[", 
     RowBox[{"Yd", ",", 
      RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu", ",", 
      RowBox[{"Adj", "[", "Yd", "]"}], ",", "md2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2"}], "]"}]}]}]], "Output",ExpressionUUID->"73edc0c1-\
3bfb-4e46-9aa6-ae2fa378385a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Abbreviations", " ", "of", " ", "Traces"}], " ", "*)"}]], "Input",E\
xpressionUUID->"1eb1934f-2dcd-4de4-828e-e399fcdb067b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceAbbr", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",ExpressionUUID->"857d4fb3-bd8b-\
4954-a363-11a14a36bd45"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Tr1", "[", "1", "]"}], ",", 
    RowBox[{
     FractionBox["3", "5"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "mHd2"}], "+", "mHu2", "+", 
       RowBox[{"trace", "[", "md2", "]"}], "+", 
       RowBox[{"trace", "[", "me2", "]"}], "-", 
       RowBox[{"trace", "[", "ml2", "]"}], "+", 
       RowBox[{"trace", "[", "mq2", "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"trace", "[", "mu2", "]"}]}]}], ")"}]}]}], "}"}], 
  "}"}]], "Output",ExpressionUUID->"e018fb61-6f53-4536-8357-2c33114801c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceAbbr", "[", 
  RowBox[{"[", "2", "]"}], "]"}]], "Input",ExpressionUUID->"ef6eb814-23fc-\
4eec-853d-b5e4d00d496a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tr2", "[", "1", "]"}], ",", 
     RowBox[{
      FractionBox["1", "10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "mHd2"}], "+", 
        RowBox[{"3", " ", "mHu2"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"trace", "[", "md2", "]"}]}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"trace", "[", "me2", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"trace", "[", "ml2", "]"}]}], "+", 
        RowBox[{"trace", "[", "mq2", "]"}], "+", 
        RowBox[{"8", " ", 
         RowBox[{"trace", "[", "mu2", "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tr3", "[", "1", "]"}], ",", 
     RowBox[{
      FractionBox["3", "10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["3", "2"]}], " ", 
         SuperscriptBox["g2", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"mHd2", "-", "mHu2", "+", 
           RowBox[{"trace", "[", "ml2", "]"}], "-", 
           RowBox[{"trace", "[", "mq2", "]"}]}], ")"}]}], "+", 
        RowBox[{
         FractionBox["8", "3"], " ", 
         SuperscriptBox["g3", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"trace", "[", "md2", "]"}], "+", 
           RowBox[{"trace", "[", "mq2", "]"}], "-", 
           RowBox[{"2", " ", 
            RowBox[{"trace", "[", "mu2", "]"}]}]}], ")"}]}], "-", 
        RowBox[{
         FractionBox["1", "30"], " ", 
         SuperscriptBox["g1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"9", " ", "mHd2"}], "-", 
           RowBox[{"9", " ", "mHu2"}], "-", 
           RowBox[{"4", " ", 
            RowBox[{"trace", "[", "md2", "]"}]}], "-", 
           RowBox[{"36", " ", 
            RowBox[{"trace", "[", "me2", "]"}]}], "+", 
           RowBox[{"9", " ", 
            RowBox[{"trace", "[", "ml2", "]"}]}], "-", 
           RowBox[{"trace", "[", "mq2", "]"}], "+", 
           RowBox[{"32", " ", 
            RowBox[{"trace", "[", "mu2", "]"}]}]}], ")"}]}], "+", 
        RowBox[{"3", " ", "mHd2", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"Yd", ",", 
           RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "+", 
        RowBox[{"mHd2", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"Ye", ",", 
           RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "-", 
        RowBox[{"3", " ", "mHu2", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"Yu", ",", 
           RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"md2", ",", "Yd", ",", 
           RowBox[{"Adj", "[", "Yd", "]"}]}], "]"}]}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"me2", ",", "Ye", ",", 
           RowBox[{"Adj", "[", "Ye", "]"}]}], "]"}]}], "+", 
        RowBox[{"trace", "[", 
         RowBox[{"ml2", ",", 
          RowBox[{"Adj", "[", "Ye", "]"}], ",", "Ye"}], "]"}], "-", 
        RowBox[{"trace", "[", 
         RowBox[{"mq2", ",", 
          RowBox[{"Adj", "[", "Yd", "]"}], ",", "Yd"}], "]"}], "-", 
        RowBox[{"trace", "[", 
         RowBox[{"mq2", ",", 
          RowBox[{"Adj", "[", "Yu", "]"}], ",", "Yu"}], "]"}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"trace", "[", 
          RowBox[{"mu2", ",", "Yu", ",", 
           RowBox[{"Adj", "[", "Yu", "]"}]}], "]"}]}]}], ")"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tr2", "[", "2", "]"}], ",", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"mHd2", "+", "mHu2", "+", 
        RowBox[{"trace", "[", "ml2", "]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"trace", "[", "mq2", "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tr2", "[", "3", "]"}], ",", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"trace", "[", "md2", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"trace", "[", "mq2", "]"}]}], "+", 
        RowBox[{"trace", "[", "mu2", "]"}]}], ")"}]}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"fef1c869-e33d-484e-adce-818d8e83add0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"MMODEL", " ", "FILES"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}]}]], "Input",ExpressionU\
UID->"e1d161ba-e2ac-478b-b0c3-d899bc8058ae"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Calculating", " ", "all", " ", "Vertices"}], " ", "*)"}]], "Input",\
ExpressionUUID->"ab8b12fa-92e0-477c-905b-6595b1d4978e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ModelOutput", "[", 
  RowBox[{"EWSB", ",", " ", 
   RowBox[{"VerticesForLoops", "\[Rule]", "True"}]}], "]"}]], "Input",Expressi\
onUUID->"efbc87d6-4172-47cd-9e58-7495e72ee3d6"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Generate Directories\"\>"], "Print",ExpressionUUID->"f219ef48-24a1-4884-9734-b4730582b7c6"],

Cell[BoxData["\<\"Building Particle List\"\>"], "Print",ExpressionUUID->"e1baad3e-b3cd-4077-b160-2428195a5e69"],

Cell[BoxData["\<\"-----------------------\"\>"], "Print",ExpressionUUID->"dacb2baf-3864-49a5-bbeb-cd670042f501"],

Cell[BoxData["\<\"Calculate All Vertices\"\>"], "Print",ExpressionUUID->"a4ba3465-0429-4a4a-9151-eadfaac87840"],

Cell[BoxData["\<\"-----------------------\"\>"], "Print",ExpressionUUID->"9791111c-4bc0-4ea2-bf65-fd590bcfd667"],

Cell[BoxData["\<\"      Three Scalar Interaction\"\>"], "Print",ExpressionUUID->"f327362e-226d-4857-bd23-574cf7791fd9"],

Cell[BoxData["\<\"      Four Scalar Interaction\"\>"], "Print",ExpressionUUID->"e0c9b665-4ef0-4161-aed8-1b0f3514c273"],

Cell[BoxData["\<\"      Two Scalar - One Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"db2860eb-b690-476d-9416-1d01eaa922cc"],

Cell[BoxData["\<\"      One Scalar - Two Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"7f52531d-4c50-4684-a33d-d69beffab4ae"],

Cell[BoxData["\<\"      Two Scalar - Two Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"5529b68a-ddba-408f-9016-89f1fa871745"],

Cell[BoxData["\<\"      Three Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"aaba3a62-d06e-44a3-b131-740324c84980"],

Cell[BoxData["\<\"      Two Fermion - One Scalar - Interaction\"\>"], "Print",ExpressionUUID->"59169519-c7f0-46b2-b226-642ead6ccd59"],

Cell[BoxData["\<\"      Two Fermion - One Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"5a3c4e83-593b-4410-adbb-3535c1207c9b"],

Cell[BoxData["\<\"      Four Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"28ba5584-fcf1-47b9-b3e1-07faab5f491f"],

Cell[BoxData["\<\"      Two Ghost - One Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"07145aff-3770-46ed-ae9c-e527786584fe"],

Cell[BoxData["\<\"      Two Ghost - One Scalar - Interaction\"\>"], "Print",ExpressionUUID->"b45dc6da-7558-4b7f-a97d-d3b15b6472dc"],

Cell[BoxData["\<\"      Two Scalar - One Auxiliary - Interaction\"\>"], \
"Print",ExpressionUUID->"1a2b6680-1631-45ee-b21f-a88c2133cb36"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"00f93977-9782-402b-b780-404c743fa94a"],

Cell[BoxData["\<\"Simplify Vertices\"\>"], "Print",ExpressionUUID->"c53abc01-601b-4a17-abd0-84920d435d9c"],

Cell[BoxData["\<\"Writing vertices to files\"\>"], "Print",ExpressionUUID->"9731a3ca-12ab-4280-b9c6-dc55ab79ac4b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done... all vertices are saved in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/\
Vertices/\"\>"}],
  SequenceForm[
  "Done... all vertices are saved in ", 
   "/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/\
Vertices/"],
  Editable->False]], "Print",ExpressionUUID->"24c932ff-6210-4a3e-a0a6-\
7e8feab092b9"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Make", " ", 
   RowBox[{"CalcHep", "/", "CompHep"}], " ", "File"}], " ", "*)"}]], "Input",E\
xpressionUUID->"49c94e68-9730-4975-b1b2-bb48b339ed64"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeCHep", "[", "]"}]], "Input",ExpressionUUID->"a168c53a-bce1-46d5-8df1-31f57cc2cff2"],

Cell[CellGroupData[{

Cell[BoxData["\<\"--------------------------------------\"\>"], "Print",ExpressionUUID->"e7ef49da-7639-4992-94cc-2cd551010d25"],

Cell[BoxData["\<\" Creating CalcHep/CompHep Model File  \"\>"], "Print",ExpressionUUID->"e7ed0088-16fe-495c-8f10-52a417efface"],

Cell[BoxData["\<\"--------------------------------------\"\>"], "Print",ExpressionUUID->"0e8ea554-4ac8-4abf-8710-d051d6168a50"],

Cell[BoxData["\<\"Sort parameters\"\>"], "Print",ExpressionUUID->"52996a17-5ff1-4785-a9e7-68e984c9894b"],

Cell[BoxData["\<\"Create C Form\"\>"], "Print",ExpressionUUID->"42fca3b7-94ed-40b8-9033-d1a3e6342bac"],

Cell[BoxData["\<\"Writing Particle List\"\>"], "Print",ExpressionUUID->"5e4d2a42-c34b-4617-a002-bac14a744b78"],

Cell[BoxData["\<\"   Scalars\"\>"], "Print",ExpressionUUID->"51ed0555-416e-48ee-8ae3-918dbaf77444"],

Cell[BoxData["\<\"   Vector Bosons\"\>"], "Print",ExpressionUUID->"188392c4-183f-46d2-88dc-f756ba1adb63"],

Cell[BoxData["\<\"   Fermions\"\>"], "Print",ExpressionUUID->"61517545-e559-4726-ae60-3838cc678d14"],

Cell[BoxData["\<\"   Auxiliary Fields\"\>"], "Print",ExpressionUUID->"da040585-37fe-43a4-82a3-a84cf6c9580e"],

Cell[BoxData["\<\"   Ghost Fields\"\>"], "Print",ExpressionUUID->"0b593a9a-39ef-40c8-9f1c-a5cbf4f35ce4"],

Cell[BoxData["\<\"Writing Variables\"\>"], "Print",ExpressionUUID->"41612e98-cb6c-468b-afc1-f38981e49841"],

Cell[BoxData["\<\"Writing Lagrangian and Functions\"\>"], "Print",ExpressionUUID->"3c9bf53e-1ced-4fde-9e18-2355fad5f05f"],

Cell[BoxData["\<\"Writing additional functions\"\>"], "Print",ExpressionUUID->"0a3ff7ba-2509-452a-ab12-0e8b2d261d20"],

Cell[BoxData["\<\"  Three Scalar Interaction\"\>"], "Print",ExpressionUUID->"ce86eaf9-55bb-49cc-b6d9-bd4728a5f998"],

Cell[BoxData["\<\"  Two Scalar - One Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"54ccb4bc-836d-46ca-a557-8f93811f16d4"],

Cell[BoxData["\<\"  One Scalar - Two Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"29213c34-e2c9-48cd-8ff7-baab7ca8101a"],

Cell[BoxData["\<\"  Two Ghost - One Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"dd25432d-2653-43fd-90e1-63f3f9d09a74"],

Cell[BoxData["\<\"  Two Ghost - One Scalar - Interaction\"\>"], "Print",ExpressionUUID->"e989ab1b-f620-4b77-a4c9-677e5fe58b41"],

Cell[BoxData["\<\"  Two Fermion - One Scalar - Interaction\"\>"], "Print",ExpressionUUID->"74a5a0f0-4ec5-47dc-8cc6-a49d7d3ed4e7"],

Cell[BoxData["\<\"  Two Fermion - One Vector Boson - Interaction\"\>"], \
"Print",ExpressionUUID->"b164e919-594e-4e97-bbab-c7303d6deaab"],

Cell[BoxData["\<\"  Four Scalar - Interaction\"\>"], "Print",ExpressionUUID->"742d1096-3b1e-430b-a4f3-9775fa44af2c"],

Cell[BoxData["\<\"  Two Scalar - One Auxiliary Field - Interaction\"\>"], \
"Print",ExpressionUUID->"638207b9-b80e-4842-8fb5-1cc99a3e1e01"],

Cell[BoxData["\<\"  Three Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"a9e3d98e-cf2f-4c3d-80dc-aef033b5f5d7"],

Cell[BoxData["\<\"  Two Scalar - Two Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"1a59f15e-d1dc-4206-a29a-da73712c39f5"],

Cell[BoxData["\<\"  Four Vector Boson - Interaction\"\>"], "Print",ExpressionUUID->"c42c7f19-a943-4c30-9300-848a5c6f01d9"],

Cell[BoxData["\<\"  One Scalar - One Vector Boson - One Auxiliary Field - \
Interaction\"\>"], "Print",ExpressionUUID->"9b98de6d-4c83-4fb5-a4f6-\
27dc94f73d2b"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"bfbe4906-2b58-490d-82cf-b0c784420874"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done. Output is in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/CHep/\
\"\>"}],
  SequenceForm[
  "Done. Output is in ", 
   "/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/CHep/"],
  Editable->False]], "Print",ExpressionUUID->"065aadf6-a010-465f-aa63-\
b8b7a3641241"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Make", " ", "FeynArts", " ", "File"}], " ", "*)"}]], "Input",Expres\
sionUUID->"24a60135-c2b7-449e-965a-cc239614b363"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeFeynArts", "[", "]"}]], "Input",
 CellChangeTimes->{{3.767692035335362*^9, 
  3.767692035426753*^9}},ExpressionUUID->"bb3afdbd-4236-4740-b37b-\
5e4b6f7a8267"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------\"\>"], "Print",ExpressionUUID->"b6a60d41-524e-48a0-8b65-5deca095bc6d"],

Cell[BoxData["\<\" Creating FeynArts Model File \"\>"], "Print",ExpressionUUID->"11bb9aa9-524f-4557-bad1-e292bc61122f"],

Cell[BoxData["\<\"------------------------------\"\>"], "Print",ExpressionUUID->"c34272ba-3ff4-4402-991f-5590f5037bac"],

Cell[BoxData["\<\"Initialize Output\"\>"], "Print",ExpressionUUID->"5677d373-a333-476b-9c38-cc0084b2a5e4"],

Cell[BoxData["\<\"Create Class Output\"\>"], "Print",ExpressionUUID->"2f70a3c0-e284-4f5f-99d8-9ef5494c22c6"],

Cell[BoxData["\<\"Create Coupling Output\"\>"], "Print",ExpressionUUID->"95a0bc1e-6880-401c-bc85-638e10b556b7"],

Cell[BoxData["\<\"Write Model-File\"\>"], "Print",ExpressionUUID->"a4477c8b-b881-478d-880c-9ebf0cba53de"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"97bb52ed-0cc3-4402-864a-ba142c720956"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done. Output is in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/\
FeynArts/\"\>"}],
  SequenceForm[
  "Done. Output is in ", 
   "/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/\
FeynArts/"],
  Editable->False]], "Print",ExpressionUUID->"7c5eeba4-a778-401a-a2b0-\
7faaa209dd47"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Make", " ", "FeynArts", " ", "with", " ", "counterterms"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MakeFeynArts", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ReadLists", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"AddCounterTerms", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"IncludeWFRConstants", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hh", ",", "Hpm", ",", 
        RowBox[{"conj", "[", "Hpm", "]"}], ",", "Ah"}], "}"}]}], ",", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"introduce", " ", "Z"}], "-", 
       RowBox[{
       "Factors", " ", "for", " ", "higgs", " ", "fields", " ", "only"}]}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"PerformSums", "\[Rule]", "True"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{
      "expand", " ", "sums", " ", "in", " ", "counter", " ", "terms"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CTDependencesPreExand", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "\[Rule]", 
         RowBox[{"EL", "/", "CTW"}]}], ",", 
        RowBox[{"g2", "\[Rule]", 
         RowBox[{"EL", "/", "STW"}]}], ",", 
        RowBox[{"vu", "\[Rule]", 
         RowBox[{"v", " ", "Sbeta"}]}], ",", 
        RowBox[{"vd", "\[Rule]", 
         RowBox[{"v", " ", "Cbeta"}]}]}], "}"}]}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"parametrise", " ", 
        RowBox[{"(", 
         RowBox[{"g1", ",", "g2", ",", "v"}], ")"}], " ", "through", " ", 
        "electric", " ", "charge"}], ",", " ", 
       RowBox[{
       "weinberg", " ", "angle", " ", "and", " ", "SM", " ", "vev"}]}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CounterTermList", "->", 
      RowBox[{"{", " ", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "expand", " ", "couplings", " ", "only", " ", "in", " ", "these", 
          " ", "counter", " ", "terms"}], ",", " ", 
         RowBox[{
          RowBox[{
          "for", " ", "generic", " ", "expansion", " ", "in", " ", "all", " ",
            "parameters", " ", "x"}], "\[Rule]", 
          RowBox[{"x", "+", "dx"}]}], ",", " ", 
         RowBox[{
         "use", " ", "default", " ", "the", " ", "value", " ", "of", " ", 
          "CounterTermList"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Yu", "[", 
           RowBox[{"a", ",", "b"}], "]"}], ",", 
          RowBox[{
           RowBox[{"IndexDelta", "[", 
            RowBox[{"a", ",", "3"}], "]"}], 
           RowBox[{"IndexDelta", "[", 
            RowBox[{"b", ",", "3"}], "]"}], "dYu"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Tu", "[", 
           RowBox[{"a", ",", "b"}], "]"}], ",", 
          RowBox[{
           RowBox[{"IndexDelta", "[", 
            RowBox[{"a", ",", "3"}], "]"}], 
           RowBox[{"IndexDelta", "[", 
            RowBox[{"b", ",", "3"}], "]"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Yu", "[", 
               RowBox[{"3", ",", "3"}], "]"}], " ", "dAt"}], "+", 
             RowBox[{"At", " ", "dYu"}]}], ")"}]}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"v", ",", "dv"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\[Mu]", ",", " ", "dmu"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Sbeta", ",", "dSbeta"}], "}"}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"{", 
         RowBox[{"Cbeta", ",", "dCbeta"}], "}"}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"{", 
         RowBox[{"Tbeta", ",", "dTbeta"}], "}"}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"{", 
         RowBox[{"STW", ",", "dSTW"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"CTW", ",", "dCTW"}], "}"}]}], "\[IndentingNewLine]", 
       "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"CTDependencesPostExand", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"dY", "->", 
        FractionBox[
         RowBox[{
          RowBox[{
           SqrtBox["2"], " ", "dmtop"}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"dv", " ", "Sbeta"}], "+", 
             RowBox[{"dSbeta", " ", "v"}]}], ")"}], " ", 
           RowBox[{"Yu", "[", 
            RowBox[{"3", ",", "3"}], "]"}]}]}], 
         RowBox[{"Sbeta", " ", "v"}]]}], "}"}]}]}], " ", 
    RowBox[{"(*", 
     RowBox[{"replacement", " ", "after", " ", "the", " ", "expansion"}], 
     "*)"}], "\[IndentingNewLine]", "]"}], ";"}]}]], "Input",
 CellChangeTimes->{{3.767692038057384*^9, 3.767692426586317*^9}, {
  3.767692468755013*^9, 
  3.767692469074038*^9}},ExpressionUUID->"71a65982-6624-45a6-a03f-\
65942cb78837"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"LOOP", " ", "CORRECTIONS"}], "  ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}]}]], "Input",ExpressionU\
UID->"c5d51b10-d4e9-4530-a194-bd4e8d346a41"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalcLoopCorrections", "[", "EWSB", "]"}]], "Input",ExpressionUUID->"5d8d6d37-0ed5-430a-b325-dde5c8322502"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Generate interaction list\"\>"], "Print",ExpressionUUID->"fab5b074-9943-4498-b401-51398582308b"],

Cell[BoxData["\<\"------------------------------------\"\>"], "Print",ExpressionUUID->"8d6f97ff-aa65-4f0c-bb86-697b0d825efd"],

Cell[BoxData["\<\"Calculate Loop Corrections\"\>"], "Print",ExpressionUUID->"890c7cf0-8e77-46f6-b43b-7ef48a603869"],

Cell[BoxData["\<\"------------------------------------\"\>"], "Print",ExpressionUUID->"3aac65d5-1e4a-4ec1-a41f-961b6654c222"],

Cell[BoxData["\<\"     For Rotated Fields\"\>"], "Print",ExpressionUUID->"0397cbbe-8d70-42db-8c50-29a73a88d834"],

Cell[BoxData["\<\"------------------------------------\"\>"], "Print",ExpressionUUID->"7232a70f-5b0e-44d1-9b83-05eba1139d22"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Sd"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Sd],
  Editable->False]], "Print",ExpressionUUID->"7eaf0516-600e-43ea-9ee1-\
ea73864c4c92"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Sv"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Sv],
  Editable->False]], "Print",ExpressionUUID->"fcbb7839-d679-4dff-84a0-\
6f86a876f22f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Su"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Su],
  Editable->False]], "Print",ExpressionUUID->"179a4d8b-e592-49ed-8001-\
2bafa1da809b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Se"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Se],
  Editable->False]], "Print",ExpressionUUID->"c54c7024-109b-4d29-895b-\
4ee703c35f9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "hh"}],
  SequenceForm["    Calculate One Loop Self Energy of ", hh],
  Editable->False]], "Print",ExpressionUUID->"2a10036c-f149-4914-9607-\
467bad091e3b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Ah"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Ah],
  Editable->False]], "Print",ExpressionUUID->"6617f8f4-65d1-4a21-891d-\
68fd400dce83"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Hpm"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Hpm],
  Editable->False]], "Print",ExpressionUUID->"df63d6eb-c050-452b-abe9-\
2124c9123881"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Chi"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Chi],
  Editable->False]], "Print",ExpressionUUID->"4cbbd71f-28cb-4208-aa6c-\
3d1f633234e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Cha"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Cha],
  Editable->False]], "Print",ExpressionUUID->"47cc3912-f7aa-4703-b281-\
414bac9584ad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Fe"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Fe],
  Editable->False]], "Print",ExpressionUUID->"35614a12-6d0c-4f9b-9f5b-\
e14b79099580"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Fd"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Fd],
  Editable->False]], "Print",ExpressionUUID->"8e2ba53f-7607-4e37-9486-\
0ec678aa6a8d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Fu"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Fu],
  Editable->False]], "Print",ExpressionUUID->"673a3cb2-ae1e-46b2-a6eb-\
ce5d46362e9d"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"e033af7f-6b21-454a-af2b-1d32b827123a"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"26c11005-2381-47b6-bee6-104152f0d3f3"],

Cell[BoxData["\<\"     For Tadpoles\"\>"], "Print",ExpressionUUID->"d8c4642c-3fc1-447d-91fe-1434c5e46315"],

Cell[BoxData["\<\"------------------------------------\"\>"], "Print",ExpressionUUID->"98206ada-c855-4506-8e48-d531e835a985"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"02b8574c-536f-419a-8c3b-7329c75f35b9"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"789c7c71-71ef-4b13-880c-66ade23f1926"],

Cell[BoxData["\<\"     For Gauge Eigenstates\"\>"], "Print",ExpressionUUID->"bd06fe3a-77c3-4ea7-98f9-911e983d1643"],

Cell[BoxData["\<\"------------------------------------\"\>"], "Print",ExpressionUUID->"568ae949-0b1f-4c54-87a8-c54b20e6e3f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "Glu"}],
  SequenceForm["    Calculate One Loop Self Energy of ", Glu],
  Editable->False]], "Print",ExpressionUUID->"439d2c20-6911-4127-bb42-\
365a8d676d92"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "VWm"}],
  SequenceForm["    Calculate One Loop Self Energy of ", VWm],
  Editable->False]], "Print",ExpressionUUID->"1197fc82-2dd9-4aea-923e-\
a9fa04bc5636"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Calculate One Loop Self Energy of \"\>", 
   "\[InvisibleSpace]", "VZ"}],
  SequenceForm["    Calculate One Loop Self Energy of ", VZ],
  Editable->False]], "Print",ExpressionUUID->"21307898-f4e0-431d-8a18-\
36b79e8d6d53"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"LaTeX", " ", "OUTPUT"}], "  ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"--", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "-"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}\
]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}]}]], "Input",ExpressionU\
UID->"3aa84293-f8b0-46ee-8a08-afc42383877c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeTeX", "[", "]"}]], "Input",ExpressionUUID->"397456d5-0a92-494f-84ae-7273be63a48a"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Writing Superfields and Superpotential to TeX-File\"\>"], \
"Print",ExpressionUUID->"d4712507-03ff-492e-aaed-fd5eb08844b5"],

Cell[BoxData["\<\"Writing Particle Content to TeX-File\"\>"], "Print",ExpressionUUID->"a6a17f09-c948-4dd5-b3a1-cea4c1720389"],

Cell[BoxData["\<\"Write VEVs to TeX-File\"\>"], "Print",ExpressionUUID->"1ce0f016-874f-4924-81d7-09fab4d330ef"],

Cell[BoxData["\<\"Write Flavor Decomposition to TeX-File\"\>"], "Print",ExpressionUUID->"a28273e9-219b-480b-9f08-0501fbb09a8d"],

Cell[BoxData["\<\"Writing Mass Matrices to TeX-File\"\>"], "Print",ExpressionUUID->"e13e0afa-d20c-4294-b7a7-961a3691435d"],

Cell[BoxData["\<\"Writing Tadpole Equations to TeX-File\"\>"], "Print",ExpressionUUID->"e61b8771-8aca-4524-9fe7-060eda61ecb4"],

Cell[BoxData["\<\"Writing RGEs to TeX-File\"\>"], "Print",ExpressionUUID->"92dcf549-cea7-4b98-9b58-8f920af40267"],

Cell[BoxData["\<\"Writing One Loop Tadpoles to TeX-File\"\>"], "Print",ExpressionUUID->"a3435ec5-ccda-4a91-89f6-d230ff6a982e"],

Cell[BoxData["\<\"Writing One Loop Self Energy to TeX-File\"\>"], "Print",ExpressionUUID->"ce48bdd9-0234-48da-b0bc-c18f20803553"],

Cell[BoxData["\<\"Writing Vertices to TeX-File\"\>"], "Print",ExpressionUUID->"c2eddc7b-6487-4e7f-8d27-d9ddc271c8b9"],

Cell[BoxData["\<\"\"\>"], "Print",ExpressionUUID->"c7d805d4-b09b-488f-8d33-cace1e509d0a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done. Output is in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/TeX/\"\
\>"}],
  SequenceForm[
  "Done. Output is in ", 
   "/home/fnstaub/Documents/Uni/SARAH/sarah-3.0.beta4/Output/MSSM/EWSB/TeX/"],
  
  Editable->False]], "Print",ExpressionUUID->"6da5996e-0d9c-4b0d-a7bc-\
56b2e6c892a5"],

Cell[BoxData["\<\"Use Script MakePDF.sh (Linux) or MakePDF.bat (Windows) to \
generate pdf file.\"\>"], "Print",ExpressionUUID->"44786108-f699-4252-8bbe-\
7addbb35b4dd"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{982, 720},
WindowMargins->{{954, Automatic}, {Automatic, 15}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (March 13, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 165, 3, 33, "Input", "ExpressionUUID" -> \
"f6b859ca-8d89-41f5-8725-3af666c69158"],
Cell[CellGroupData[{
Cell[748, 27, 106, 1, 33, "Input", "ExpressionUUID" -> \
"e25089f2-9026-432c-bb11-d17747f3a383"],
Cell[CellGroupData[{
Cell[879, 32, 104, 0, 25, "Print", "ExpressionUUID" -> \
"1a16dfc9-ba0e-4b1d-982f-f0c204e5f08b"],
Cell[986, 34, 111, 0, 27, "Print", "ExpressionUUID" -> \
"238ed1ee-6204-4806-bbda-3c377e84dac2"],
Cell[1100, 36, 89, 0, 25, "Print", "ExpressionUUID" -> \
"948bb090-7de1-4661-852c-6c89b4759c9a"],
Cell[1192, 38, 159, 2, 25, "Print", "ExpressionUUID" -> \
"c675b099-6d5a-44c7-8e10-b51bf6b042fa"],
Cell[1354, 42, 153, 2, 27, "Print", "ExpressionUUID" -> \
"9dbb4209-4c8f-4757-a2d6-24b04d34bedb"]
}, Open  ]]
}, Open  ]],
Cell[1534, 48, 943, 32, 103, "Input", "ExpressionUUID" -> \
"540810d7-54c7-44ea-a1fa-1799974bf782"],
Cell[CellGroupData[{
Cell[2502, 84, 124, 1, 33, "Input", "ExpressionUUID" -> \
"ec4f72d7-698a-402c-961e-c8bf7d8166fc"],
Cell[CellGroupData[{
Cell[2651, 89, 103, 0, 25, "Print", "ExpressionUUID" -> \
"6a1d683b-79aa-4d23-b027-de865e0673eb"],
Cell[2757, 91, 89, 0, 25, "Print", "ExpressionUUID" -> \
"e61af75b-ac58-40fb-b042-b9ec828c89d0"],
Cell[2849, 93, 119, 0, 25, "Print", "ExpressionUUID" -> \
"1c74e509-c417-408c-b0c7-e9d683720979"],
Cell[2971, 95, 113, 0, 25, "Print", "ExpressionUUID" -> \
"fbafbfc8-54d1-43fe-97c8-f51c86ebf7db"],
Cell[3087, 97, 116, 0, 25, "Print", "ExpressionUUID" -> \
"7f4ed706-ee4b-49d9-b34f-eab01a83446e"],
Cell[3206, 99, 119, 0, 25, "Print", "ExpressionUUID" -> \
"4c3a76ca-7242-4b28-b5cd-4a59af3290b2"],
Cell[3328, 101, 118, 0, 25, "Print", "ExpressionUUID" -> \
"227059c0-98d9-48a7-9a11-f49fc5af2c5d"],
Cell[3449, 103, 104, 0, 25, "Print", "ExpressionUUID" -> \
"d0d4025a-7362-4a3a-a0ef-2eb242e674af"],
Cell[3556, 105, 306, 6, 25, "Print", "ExpressionUUID" -> \
"e0430ead-3b14-42d0-852f-c588100bda30"],
Cell[3865, 113, 111, 0, 25, "Print", "ExpressionUUID" -> \
"75c7e840-322e-4c6a-9164-d2641565a443"],
Cell[3979, 115, 390, 7, 25, "Print", "ExpressionUUID" -> \
"5c0af10e-89df-4f22-b50a-6eca7fc05c86"],
Cell[4372, 124, 294, 6, 25, "Print", "ExpressionUUID" -> \
"2f3db33b-be76-404b-9f60-08f636d554ee"],
Cell[4669, 132, 392, 7, 25, "Print", "ExpressionUUID" -> \
"0c2beb9a-3ffd-46f7-a8e3-438f99545635"],
Cell[5064, 141, 108, 0, 25, "Print", "ExpressionUUID" -> \
"1a6f38c8-dc6d-4a23-833a-c6dab951865d"],
Cell[5175, 143, 137, 1, 25, "Print", "ExpressionUUID" -> \
"488c49cd-72bd-4fa3-85a8-0f57a14808b3"],
Cell[5315, 146, 151, 2, 25, "Print", "ExpressionUUID" -> \
"3677b296-3bdf-40d9-b2f9-40b7530ba4c3"],
Cell[5469, 150, 101, 0, 25, "Print", "ExpressionUUID" -> \
"3ef61ba9-7cc2-42d5-9963-2fe416a0646a"],
Cell[5573, 152, 108, 0, 25, "Print", "ExpressionUUID" -> \
"0da570e7-fa86-4bd1-a377-e2440bc37437"],
Cell[5684, 154, 107, 0, 25, "Print", "ExpressionUUID" -> \
"471085c7-1da7-4df1-9807-9b9130649b91"],
Cell[5794, 156, 107, 0, 25, "Print", "ExpressionUUID" -> \
"4bd72022-af2a-4822-afcd-2a37bbd564a2"],
Cell[5904, 158, 101, 0, 25, "Print", "ExpressionUUID" -> \
"e3bf7b61-ed62-4462-a671-93d8cef3f45f"],
Cell[6008, 160, 114, 0, 25, "Print", "ExpressionUUID" -> \
"e9121cf1-3f86-4d94-a536-9e2dbf5eab36"],
Cell[6125, 162, 129, 0, 25, "Print", "ExpressionUUID" -> \
"21f27b80-8170-4a75-9dae-1e5b0244fcea"],
Cell[6257, 164, 138, 1, 25, "Print", "ExpressionUUID" -> \
"648e1032-4c67-4776-b4ed-2eeb275f47b4"],
Cell[6398, 167, 115, 0, 25, "Print", "ExpressionUUID" -> \
"e5741b2d-c757-4864-bf3c-d1aac3b2b317"],
Cell[6516, 169, 113, 0, 25, "Print", "ExpressionUUID" -> \
"f3181f2f-0927-461a-a14f-0a352ccc3135"],
Cell[6632, 171, 89, 0, 25, "Print", "ExpressionUUID" -> \
"9a45eaf1-17c0-41c1-b9a5-2ccc89414136"],
Cell[6724, 173, 124, 0, 25, "Print", "ExpressionUUID" -> \
"3cb9074a-a5cf-4fd6-992b-b1feb859abd9"],
Cell[6851, 175, 248, 6, 25, "Print", "ExpressionUUID" -> \
"5f697e7c-dcfc-4821-996e-29c451246ee0"],
Cell[7102, 183, 124, 0, 25, "Print", "ExpressionUUID" -> \
"72c57a8f-50ba-46a8-bd73-958ba096b189"],
Cell[7229, 185, 118, 0, 25, "Print", "ExpressionUUID" -> \
"e742ee29-8790-4227-a98f-c4bbc4174b54"],
Cell[7350, 187, 112, 0, 25, "Print", "ExpressionUUID" -> \
"ebe6753e-6e3c-44bc-b395-98eabd5334f0"],
Cell[7465, 189, 253, 5, 25, "Print", "ExpressionUUID" -> \
"d7904dc9-ce17-45c9-b9b2-3018a6bc757e"],
Cell[7721, 196, 111, 0, 25, "Print", "ExpressionUUID" -> \
"207c38a3-2faf-424c-ae82-40672783153b"],
Cell[7835, 198, 107, 0, 25, "Print", "ExpressionUUID" -> \
"e339eedd-8153-4381-8092-8f7e63d80c6a"],
Cell[7945, 200, 111, 0, 25, "Print", "ExpressionUUID" -> \
"812a4e7e-48d3-424e-847e-303290aa16fa"],
Cell[8059, 202, 89, 0, 25, "Print", "ExpressionUUID" -> \
"3fa708ab-5525-4a71-a50c-4edec33495f9"],
Cell[8151, 204, 124, 0, 25, "Print", "ExpressionUUID" -> \
"dbb37f0f-3891-40e1-89a0-fc2561d7c134"],
Cell[8278, 206, 239, 5, 25, "Print", "ExpressionUUID" -> \
"228b6118-7ca6-46a0-8dfb-e6fed1ac39b9"],
Cell[8520, 213, 124, 0, 25, "Print", "ExpressionUUID" -> \
"15dd92d1-28ca-4828-8db3-639b197bbe02"],
Cell[8647, 215, 113, 0, 25, "Print", "ExpressionUUID" -> \
"31441e34-d86e-4b60-8377-e483b125b24d"],
Cell[8763, 217, 114, 0, 25, "Print", "ExpressionUUID" -> \
"bc03840f-ef72-4ef1-b32a-b92356b088ca"],
Cell[8880, 219, 99, 0, 25, "Print", "ExpressionUUID" -> \
"70b9d9b7-f8e0-491a-b06b-b6af15eefbda"],
Cell[8982, 221, 118, 0, 25, "Print", "ExpressionUUID" -> \
"b2ca419a-3734-4350-a1a0-39de6159cb1c"],
Cell[9103, 223, 107, 0, 25, "Print", "ExpressionUUID" -> \
"355d5daf-706f-4c59-b8f0-a14b5d119c1f"],
Cell[9213, 225, 271, 7, 29, "Print", "ExpressionUUID" -> \
"7633e33e-8323-47ff-8e98-a45a5faba93e"],
Cell[9487, 234, 239, 6, 25, "Print", "ExpressionUUID" -> \
"f4ca9184-841a-474f-ba1f-a203d8ac2f2a"],
Cell[9729, 242, 271, 7, 27, "Print", "ExpressionUUID" -> \
"4288d34d-4e54-475e-aabe-3c05efb3d847"],
Cell[10003, 251, 271, 7, 27, "Print", "ExpressionUUID" -> \
"9f707bb6-823e-4337-9828-646ddf64de79"],
Cell[10277, 260, 275, 7, 29, "Print", "ExpressionUUID" -> \
"da69a155-1e63-433a-ad29-abda356c33ff"],
Cell[10555, 269, 283, 7, 29, "Print", "ExpressionUUID" -> \
"a52b97f9-68d7-45ca-bd1f-bd225d196763"],
Cell[10841, 278, 320, 9, 29, "Print", "ExpressionUUID" -> \
"422e45b9-9747-4461-b9d2-144bff6279b9"],
Cell[11164, 289, 307, 7, 29, "Print", "ExpressionUUID" -> \
"19d7f5b3-7706-4e11-b26f-32439278ef39"],
Cell[11474, 298, 366, 9, 29, "Print", "ExpressionUUID" -> \
"cfe42683-4275-4b97-a992-d9ff85cf1027"],
Cell[11843, 309, 342, 9, 29, "Print", "ExpressionUUID" -> \
"2b1f8207-4731-42e1-8a0a-8c8c8ec38fd5"],
Cell[12188, 320, 342, 9, 29, "Print", "ExpressionUUID" -> \
"f1f27ef4-0712-48c5-8d4c-a65edb9eb448"],
Cell[12533, 331, 342, 9, 29, "Print", "ExpressionUUID" -> \
"5108a5e7-ddfe-448e-ac63-1085ff2d9b19"],
Cell[12878, 342, 116, 0, 25, "Print", "ExpressionUUID" -> \
"982b611d-c62b-474f-87d4-c4d9ca64ecef"],
Cell[12997, 344, 112, 0, 25, "Print", "ExpressionUUID" -> \
"f282b04b-4f88-4884-886c-c292bdbc9c52"],
Cell[13112, 346, 247, 5, 25, "Print", "ExpressionUUID" -> \
"d10a0bf3-f8c0-4d65-bd45-ebba0cf35fdb"],
Cell[13362, 353, 111, 0, 25, "Print", "ExpressionUUID" -> \
"7d72be7e-8743-44c1-ba95-9366b6e43c09"],
Cell[13476, 355, 107, 0, 25, "Print", "ExpressionUUID" -> \
"f9e42ee6-982d-44e4-9c36-086ce7765ba8"],
Cell[13586, 357, 111, 0, 25, "Print", "ExpressionUUID" -> \
"1fc75be6-1272-4bc8-8c36-7daaa307de6f"],
Cell[13700, 359, 89, 0, 25, "Print", "ExpressionUUID" -> \
"08453245-69ac-44d7-bbf5-91bcb6b63fa2"],
Cell[13792, 361, 124, 0, 25, "Print", "ExpressionUUID" -> \
"0136e2cc-5d58-47fc-8e0b-08a7d833a26e"],
Cell[13919, 363, 98, 0, 25, "Print", "ExpressionUUID" -> \
"5463dbd8-fccb-4802-a62f-b3bf13ace204"],
Cell[14020, 365, 124, 0, 25, "Print", "ExpressionUUID" -> \
"de9578d9-257c-45b3-8352-9bfee099b28f"],
Cell[14147, 367, 115, 0, 25, "Print", "ExpressionUUID" -> \
"19101e53-585d-476e-b569-a79ce4a23859"],
Cell[14265, 369, 108, 0, 25, "Print", "ExpressionUUID" -> \
"bd2d521f-c22a-42d7-9aeb-5706b1ca0b66"],
Cell[14376, 371, 120, 0, 25, "Print", "ExpressionUUID" -> \
"7629bbd3-6a05-4a58-884c-6da1290adcc5"],
Cell[14499, 373, 118, 0, 25, "Print", "ExpressionUUID" -> \
"421afd07-c2e3-4116-bb38-fdfca3a9a65f"],
Cell[14620, 375, 223, 5, 25, "Print", "ExpressionUUID" -> \
"aca3ab40-f263-485a-b084-b7290113f7df"],
Cell[14846, 382, 217, 5, 25, "Print", "ExpressionUUID" -> \
"1e2b5357-9766-4129-bb14-5e1c8b90aa7e"],
Cell[15066, 389, 111, 0, 25, "Print", "ExpressionUUID" -> \
"9e1fdd08-f69f-48e9-b805-590326b08405"],
Cell[15180, 391, 115, 0, 25, "Print", "ExpressionUUID" -> \
"ad757b3f-69b1-4cd4-a983-8f3ecb7133ff"],
Cell[15298, 393, 129, 0, 25, "Print", "ExpressionUUID" -> \
"9108b1c1-8b52-4570-b376-0c87b52453b0"],
Cell[15430, 395, 114, 0, 25, "Print", "ExpressionUUID" -> \
"dc9dae8b-12f5-4ed4-8bea-10e7004b5adf"],
Cell[15547, 397, 89, 0, 25, "Print", "ExpressionUUID" -> \
"8a96bbe8-33b8-42bd-b460-7fcad9dbb228"],
Cell[15639, 399, 294, 6, 25, "Print", "ExpressionUUID" -> \
"84cf4add-1efd-4002-83ca-5482bf0b93ca"]
}, Open  ]]
}, Open  ]],
Cell[15960, 409, 6539, 196, 126, "Input", "ExpressionUUID" -> \
"5aea6363-cc00-46c8-9eba-3066054ecb6c"],
Cell[CellGroupData[{
Cell[22524, 609, 324, 7, 80, "Input", "ExpressionUUID" -> \
"77b5b1f4-2f12-45fa-b8b0-f4907f7f1116"],
Cell[22851, 618, 4581, 132, 386, "Output", "ExpressionUUID" -> \
"64206a1d-3986-4b4d-b06c-a4c44f020834"]
}, Open  ]],
Cell[27447, 753, 209, 5, 33, "Input", "ExpressionUUID" -> \
"eb3db5be-71af-41c3-afc8-09decacef83c"],
Cell[CellGroupData[{
Cell[27681, 762, 119, 1, 33, "Input", "ExpressionUUID" -> \
"592d3cdf-a85c-4e4d-9a20-91b7306ec345"],
Cell[27803, 765, 2406, 73, 138, "Output", "ExpressionUUID" -> \
"2d742b92-585d-4a5f-a738-8fbb57aa770a"]
}, Open  ]],
Cell[30224, 841, 81, 0, 33, "Input", "ExpressionUUID" -> \
"612a6b6d-8c3c-4f9d-8c4c-55a0fdc5a737"],
Cell[CellGroupData[{
Cell[30330, 845, 316, 8, 103, "Input", "ExpressionUUID" -> \
"7bccd167-37b7-44f9-8025-26b5ebbe5c4a"],
Cell[30649, 855, 1001, 33, 92, "Output", "ExpressionUUID" -> \
"e529b9f2-8501-4901-914f-b3c456d8793f"]
}, Open  ]],
Cell[31665, 891, 6511, 195, 126, "Input", "ExpressionUUID" -> \
"b16cd9b5-2dc6-47a9-99aa-593fb611260a"],
Cell[38179, 1088, 233, 5, 33, "Input", "ExpressionUUID" -> \
"e07ad035-fbb5-4c5b-ae17-fed0c7668924"],
Cell[CellGroupData[{
Cell[38437, 1097, 209, 5, 35, "Input", "ExpressionUUID" -> \
"c09b307f-fbc3-475e-833b-ee3951ee8123"],
Cell[38649, 1104, 2243, 63, 164, "Output", "ExpressionUUID" -> \
"ec8aa054-2a55-4338-9ff8-c2dd43f584e4"]
}, Open  ]],
Cell[40907, 1170, 239, 5, 33, "Input", "ExpressionUUID" -> \
"897541a7-9f1a-4593-9138-d2beee61e162"],
Cell[CellGroupData[{
Cell[41171, 1179, 210, 5, 35, "Input", "ExpressionUUID" -> \
"8821728f-5f6a-4f79-885a-3a7db1e0113a"],
Cell[41384, 1186, 1721, 48, 134, "Output", "ExpressionUUID" -> \
"1be1edb8-6731-4abf-aa86-7d6cda99f91c"]
}, Open  ]],
Cell[43120, 1237, 220, 5, 33, "Input", "ExpressionUUID" -> \
"3a649b19-d5d5-4c2b-9802-8d83d6a2e18c"],
Cell[CellGroupData[{
Cell[43365, 1246, 211, 5, 35, "Input", "ExpressionUUID" -> \
"5f5cf40c-a501-4376-aa75-51ea0424e6ab"],
Cell[43579, 1253, 2106, 66, 107, "Output", "ExpressionUUID" -> \
"01f6a41d-389a-4b80-b36d-2fd9eb357cb0"]
}, Open  ]],
Cell[45700, 1322, 145, 3, 33, "Input", "ExpressionUUID" -> \
"2cf72844-d2b5-4543-b664-435540385845"],
Cell[CellGroupData[{
Cell[45870, 1329, 187, 4, 35, "Input", "ExpressionUUID" -> \
"9cb5cf59-ff49-4720-9e89-c8cb0115469c"],
Cell[46060, 1335, 3396, 95, 158, "Output", "ExpressionUUID" -> \
"521d50ca-f62d-4dc0-9c50-6df3690cd6ce"]
}, Open  ]],
Cell[49471, 1433, 353, 8, 33, "Input", "ExpressionUUID" -> \
"07284f2e-9a1a-4528-8a05-2ea797362042"],
Cell[CellGroupData[{
Cell[49849, 1445, 292, 8, 35, "Input", "ExpressionUUID" -> \
"14fb7edf-718b-4cac-873f-382a9f68530e"],
Cell[50144, 1455, 1159, 36, 81, "Output", "ExpressionUUID" -> \
"88218c82-c4dc-4da2-8847-22279bd18162"]
}, Open  ]],
Cell[51318, 1494, 186, 3, 33, "Input", "ExpressionUUID" -> \
"b2e488cb-0424-4132-b2d1-84355b457af6"],
Cell[CellGroupData[{
Cell[51529, 1501, 280, 7, 35, "Input", "ExpressionUUID" -> \
"e34ead6a-f27e-4639-b83a-09659bae1945"],
Cell[51812, 1510, 972, 28, 59, "Output", "ExpressionUUID" -> \
"5ff86530-9ea4-4894-b119-3f024eb70b2a"]
}, Open  ]],
Cell[52799, 1541, 6614, 198, 172, "Input", "ExpressionUUID" -> \
"cf6c1235-34d1-40a4-b37f-f32f2945707b"],
Cell[CellGroupData[{
Cell[59438, 1743, 111, 1, 33, "Input", "ExpressionUUID" -> \
"b635d0fc-9a09-48e7-a76a-6a8e0ab36734"],
Cell[CellGroupData[{
Cell[59574, 1748, 112, 0, 25, "Print", "ExpressionUUID" -> \
"6aa4314e-3181-4d60-a124-0c1dc0690585"],
Cell[59689, 1750, 106, 0, 25, "Print", "ExpressionUUID" -> \
"793101d6-769d-4c1e-8188-b3b440399639"],
Cell[59798, 1752, 112, 0, 25, "Print", "ExpressionUUID" -> \
"d9661af2-2ce3-46f6-8059-b6f39fd0aff2"],
Cell[59913, 1754, 128, 0, 25, "Print", "ExpressionUUID" -> \
"685a62d2-1ff2-45fa-9929-d5654d8e1565"],
Cell[60044, 1756, 121, 0, 25, "Print", "ExpressionUUID" -> \
"6f9d7153-981c-45e1-b2b8-a19f9e0c6eb0"],
Cell[60168, 1758, 162, 2, 23, "Print", "ExpressionUUID" -> \
"3a59211a-de4f-4852-a770-f5d2b8f91df2"],
Cell[60333, 1762, 161, 2, 23, "Print", "ExpressionUUID" -> \
"f02ff1f2-2f33-4d74-813b-1b0fe22d3d6c"],
Cell[60497, 1766, 160, 2, 23, "Print", "ExpressionUUID" -> \
"f93e0b30-d45a-4bb5-82a4-4856d6766844"],
Cell[60660, 1770, 158, 2, 23, "Print", "ExpressionUUID" -> \
"6d2b3a28-97b7-4d3f-8bbd-76cf9d3a29a2"],
Cell[60821, 1774, 157, 2, 25, "Print", "ExpressionUUID" -> \
"77bb77b8-2694-47e4-875e-70107ce1aace"],
Cell[60981, 1778, 155, 2, 25, "Print", "ExpressionUUID" -> \
"644e7f0c-43ba-4f31-a4f2-e2e53cc1154b"],
Cell[61139, 1782, 133, 0, 25, "Print", "ExpressionUUID" -> \
"c212a9a4-b622-4cb9-937c-0cd1c1bfc0e0"],
Cell[61275, 1784, 134, 0, 25, "Print", "ExpressionUUID" -> \
"275dbb11-31ae-4131-9feb-5e039404436b"],
Cell[61412, 1786, 137, 1, 25, "Print", "ExpressionUUID" -> \
"4f3d11a4-4893-4fca-93ae-b027eb9f1b37"],
Cell[61552, 1789, 163, 2, 25, "Print", "ExpressionUUID" -> \
"4ef1d4d2-4835-417d-a628-ee1535dab730"],
Cell[61718, 1793, 124, 0, 25, "Print", "ExpressionUUID" -> \
"c5be9209-06fd-40e2-92a5-3522bb37f42f"]
}, Open  ]]
}, Open  ]],
Cell[61869, 1797, 188, 4, 33, "Input", "ExpressionUUID" -> \
"09db5274-0925-43b4-bb29-cf49038092f8"],
Cell[CellGroupData[{
Cell[62082, 1805, 165, 4, 35, "Input", "ExpressionUUID" -> \
"2a4f2696-b5a6-4312-acd7-25adc282c627"],
Cell[62250, 1811, 138, 3, 35, "Output", "ExpressionUUID" -> \
"c547f455-c397-4f96-a51c-19e35930a88b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62425, 1819, 165, 4, 35, "Input", "ExpressionUUID" -> \
"dae49bc4-4d97-44f6-a3cd-d60f53a0f541"],
Cell[62593, 1825, 962, 30, 75, "Output", "ExpressionUUID" -> \
"23a74f57-f3f4-4ead-bb6d-cc6566efadd4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63592, 1860, 165, 4, 35, "Input", "ExpressionUUID" -> \
"2126f631-bc44-4772-8f26-17e659900f3b"],
Cell[63760, 1866, 3642, 109, 270, "Output", "ExpressionUUID" -> \
"51d46834-4ffe-48e8-a444-f90ddcc065be"]
}, Open  ]],
Cell[67417, 1978, 168, 3, 33, "Input", "ExpressionUUID" -> \
"0eb744cc-2942-4d2b-bb79-5ff1ff1a22e9"],
Cell[CellGroupData[{
Cell[67610, 1985, 164, 4, 35, "Input", "ExpressionUUID" -> \
"9a756fb6-5b4f-4398-b024-1d545c98bbc7"],
Cell[67777, 1991, 114, 1, 33, "Output", "ExpressionUUID" -> \
"1fc186ac-cddd-4757-ba4f-844fc32ec532"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67928, 1997, 164, 4, 35, "Input", "ExpressionUUID" -> \
"98f767e4-00e8-4b52-a9f2-32eae1da3bb3"],
Cell[68095, 2003, 1457, 43, 126, "Output", "ExpressionUUID" -> \
"d657844e-e223-4592-b6ef-6d53726a139f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69589, 2051, 164, 4, 35, "Input", "ExpressionUUID" -> \
"7bcf429d-1e86-4930-97cb-0fb7724fda44"],
Cell[69756, 2057, 5831, 162, 361, "Output", "ExpressionUUID" -> \
"641cc08b-5af7-4c7a-bfc1-3fa67f8cfba4"]
}, Open  ]],
Cell[75602, 2222, 192, 4, 33, "Input", "ExpressionUUID" -> \
"a9ddff40-8988-4500-b17b-95fb174f0fbd"],
Cell[CellGroupData[{
Cell[75819, 2230, 166, 4, 35, "Input", "ExpressionUUID" -> \
"17a49d8b-9cb7-4183-bb9f-0bf69c99f5f1"],
Cell[75988, 2236, 84, 0, 33, "Output", "ExpressionUUID" -> \
"a3423cdb-8152-44c1-abf4-2d76b879abc7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76109, 2241, 166, 4, 35, "Input", "ExpressionUUID" -> \
"ecfcc68d-48da-45d8-95a0-313318ed0b73"],
Cell[76278, 2247, 155, 4, 54, "Output", "ExpressionUUID" -> \
"51491a89-9158-4a8f-87e4-d80d007fd783"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76470, 2256, 166, 4, 35, "Input", "ExpressionUUID" -> \
"9eeace44-b0d4-48c9-a3bb-aabfb1aad06d"],
Cell[76639, 2262, 792, 24, 78, "Output", "ExpressionUUID" -> \
"b4e62d67-bd0d-437d-8977-f82c979ea021"]
}, Open  ]],
Cell[77446, 2289, 189, 3, 33, "Input", "ExpressionUUID" -> \
"ba5e4f76-7e7c-40f6-926a-8350f6373c66"],
Cell[CellGroupData[{
Cell[77660, 2296, 165, 4, 35, "Input", "ExpressionUUID" -> \
"415c834a-66d1-4452-ba36-a688993a8de4"],
Cell[77828, 2302, 139, 3, 35, "Output", "ExpressionUUID" -> \
"24975d8d-27f1-4ce8-91f4-36986dbbfd84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78004, 2310, 165, 4, 35, "Input", "ExpressionUUID" -> \
"8627dede-48b1-4919-b443-2e5b655ecfec"],
Cell[78172, 2316, 2054, 56, 141, "Output", "ExpressionUUID" -> \
"1f36f525-ee4c-4fa1-96c0-e45475320017"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80263, 2377, 165, 4, 35, "Input", "ExpressionUUID" -> \
"b122da15-aa7f-4b8b-88d1-2c9e2efa6acc"],
Cell[80431, 2383, 18277, 543, 1160, "Output", "ExpressionUUID" -> \
"73edc0c1-3bfb-4e46-9aa6-ae2fa378385a"]
}, Open  ]],
Cell[98723, 2929, 169, 3, 33, "Input", "ExpressionUUID" -> \
"1eb1934f-2dcd-4de4-828e-e399fcdb067b"],
Cell[CellGroupData[{
Cell[98917, 2936, 142, 3, 33, "Input", "ExpressionUUID" -> \
"857d4fb3-bd8b-4954-a363-11a14a36bd45"],
Cell[99062, 2941, 592, 16, 50, "Output", "ExpressionUUID" -> \
"e018fb61-6f53-4536-8357-2c33114801c5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99691, 2962, 142, 3, 33, "Input", "ExpressionUUID" -> \
"ef6eb814-23fc-4eec-853d-b5e4d00d496a"],
Cell[99836, 2967, 4264, 116, 319, "Output", "ExpressionUUID" -> \
"fef1c869-e33d-484e-adce-818d8e83add0"]
}, Open  ]],
Cell[104115, 3086, 6536, 196, 126, "Input", "ExpressionUUID" -> \
"e1d161ba-e2ac-478b-b0c3-d899bc8058ae"],
Cell[110654, 3284, 170, 3, 33, "Input", "ExpressionUUID" -> \
"ab8b12fa-92e0-477c-905b-6595b1d4978e"],
Cell[CellGroupData[{
Cell[110849, 3291, 200, 4, 35, "Input", "ExpressionUUID" -> \
"efbc87d6-4172-47cd-9e58-7495e72ee3d6"],
Cell[CellGroupData[{
Cell[111074, 3299, 109, 0, 25, "Print", "ExpressionUUID" -> \
"f219ef48-24a1-4884-9734-b4730582b7c6"],
Cell[111186, 3301, 111, 0, 25, "Print", "ExpressionUUID" -> \
"e1baad3e-b3cd-4077-b160-2428195a5e69"],
Cell[111300, 3303, 112, 0, 25, "Print", "ExpressionUUID" -> \
"dacb2baf-3864-49a5-bbeb-cd670042f501"],
Cell[111415, 3305, 111, 0, 25, "Print", "ExpressionUUID" -> \
"a4ba3465-0429-4a4a-9151-eadfaac87840"],
Cell[111529, 3307, 112, 0, 25, "Print", "ExpressionUUID" -> \
"9791111c-4bc0-4ea2-bf65-fd590bcfd667"],
Cell[111644, 3309, 119, 0, 25, "Print", "ExpressionUUID" -> \
"f327362e-226d-4857-bd23-574cf7791fd9"],
Cell[111766, 3311, 118, 0, 25, "Print", "ExpressionUUID" -> \
"e0c9b665-4ef0-4161-aed8-1b0f3514c273"],
Cell[111887, 3313, 140, 1, 25, "Print", "ExpressionUUID" -> \
"db2860eb-b690-476d-9416-1d01eaa922cc"],
Cell[112030, 3316, 140, 1, 25, "Print", "ExpressionUUID" -> \
"7f52531d-4c50-4684-a33d-d69beffab4ae"],
Cell[112173, 3319, 140, 1, 25, "Print", "ExpressionUUID" -> \
"5529b68a-ddba-408f-9016-89f1fa871745"],
Cell[112316, 3322, 127, 0, 25, "Print", "ExpressionUUID" -> \
"aaba3a62-d06e-44a3-b131-740324c84980"],
Cell[112446, 3324, 133, 0, 25, "Print", "ExpressionUUID" -> \
"59169519-c7f0-46b2-b226-642ead6ccd59"],
Cell[112582, 3326, 141, 1, 25, "Print", "ExpressionUUID" -> \
"5a3c4e83-593b-4410-adbb-3535c1207c9b"],
Cell[112726, 3329, 126, 0, 25, "Print", "ExpressionUUID" -> \
"28ba5584-fcf1-47b9-b3e1-07faab5f491f"],
Cell[112855, 3331, 139, 1, 25, "Print", "ExpressionUUID" -> \
"07145aff-3770-46ed-ae9c-e527786584fe"],
Cell[112997, 3334, 131, 0, 25, "Print", "ExpressionUUID" -> \
"b45dc6da-7558-4b7f-a97d-d3b15b6472dc"],
Cell[113131, 3336, 137, 1, 25, "Print", "ExpressionUUID" -> \
"1a2b6680-1631-45ee-b21f-a88c2133cb36"],
Cell[113271, 3339, 89, 0, 25, "Print", "ExpressionUUID" -> \
"00f93977-9782-402b-b780-404c743fa94a"],
Cell[113363, 3341, 106, 0, 25, "Print", "ExpressionUUID" -> \
"c53abc01-601b-4a17-abd0-84920d435d9c"],
Cell[113472, 3343, 114, 0, 25, "Print", "ExpressionUUID" -> \
"9731a3ca-12ab-4280-b9c6-dc55ab79ac4b"],
Cell[113589, 3345, 438, 11, 48, "Print", "ExpressionUUID" -> \
"24c932ff-6210-4a3e-a0a6-7e8feab092b9"]
}, Open  ]]
}, Open  ]],
Cell[114054, 3360, 193, 4, 33, "Input", "ExpressionUUID" -> \
"49c94e68-9730-4975-b1b2-bb48b339ed64"],
Cell[CellGroupData[{
Cell[114272, 3368, 111, 1, 33, "Input", "ExpressionUUID" -> \
"a168c53a-bce1-46d5-8df1-31f57cc2cff2"],
Cell[CellGroupData[{
Cell[114408, 3373, 127, 0, 25, "Print", "ExpressionUUID" -> \
"e7ef49da-7639-4992-94cc-2cd551010d25"],
Cell[114538, 3375, 127, 0, 25, "Print", "ExpressionUUID" -> \
"e7ed0088-16fe-495c-8f10-52a417efface"],
Cell[114668, 3377, 127, 0, 25, "Print", "ExpressionUUID" -> \
"0e8ea554-4ac8-4abf-8710-d051d6168a50"],
Cell[114798, 3379, 104, 0, 25, "Print", "ExpressionUUID" -> \
"52996a17-5ff1-4785-a9e7-68e984c9894b"],
Cell[114905, 3381, 102, 0, 25, "Print", "ExpressionUUID" -> \
"42fca3b7-94ed-40b8-9033-d1a3e6342bac"],
Cell[115010, 3383, 110, 0, 25, "Print", "ExpressionUUID" -> \
"5e4d2a42-c34b-4617-a002-bac14a744b78"],
Cell[115123, 3385, 99, 0, 25, "Print", "ExpressionUUID" -> \
"51ed0555-416e-48ee-8ae3-918dbaf77444"],
Cell[115225, 3387, 105, 0, 25, "Print", "ExpressionUUID" -> \
"188392c4-183f-46d2-88dc-f756ba1adb63"],
Cell[115333, 3389, 100, 0, 25, "Print", "ExpressionUUID" -> \
"61517545-e559-4726-ae60-3838cc678d14"],
Cell[115436, 3391, 108, 0, 25, "Print", "ExpressionUUID" -> \
"da040585-37fe-43a4-82a3-a84cf6c9580e"],
Cell[115547, 3393, 104, 0, 25, "Print", "ExpressionUUID" -> \
"0b593a9a-39ef-40c8-9f1c-a5cbf4f35ce4"],
Cell[115654, 3395, 106, 0, 25, "Print", "ExpressionUUID" -> \
"41612e98-cb6c-468b-afc1-f38981e49841"],
Cell[115763, 3397, 121, 0, 25, "Print", "ExpressionUUID" -> \
"3c9bf53e-1ced-4fde-9e18-2355fad5f05f"],
Cell[115887, 3399, 117, 0, 25, "Print", "ExpressionUUID" -> \
"0a3ff7ba-2509-452a-ab12-0e8b2d261d20"],
Cell[116007, 3401, 115, 0, 25, "Print", "ExpressionUUID" -> \
"ce86eaf9-55bb-49cc-b6d9-bd4728a5f998"],
Cell[116125, 3403, 134, 0, 25, "Print", "ExpressionUUID" -> \
"54ccb4bc-836d-46ca-a557-8f93811f16d4"],
Cell[116262, 3405, 134, 0, 25, "Print", "ExpressionUUID" -> \
"29213c34-e2c9-48cd-8ff7-baab7ca8101a"],
Cell[116399, 3407, 133, 0, 25, "Print", "ExpressionUUID" -> \
"dd25432d-2653-43fd-90e1-63f3f9d09a74"],
Cell[116535, 3409, 127, 0, 25, "Print", "ExpressionUUID" -> \
"e989ab1b-f620-4b77-a4c9-677e5fe58b41"],
Cell[116665, 3411, 129, 0, 25, "Print", "ExpressionUUID" -> \
"74a5a0f0-4ec5-47dc-8cc6-a49d7d3ed4e7"],
Cell[116797, 3413, 137, 1, 25, "Print", "ExpressionUUID" -> \
"b164e919-594e-4e97-bbab-c7303d6deaab"],
Cell[116937, 3416, 116, 0, 25, "Print", "ExpressionUUID" -> \
"742d1096-3b1e-430b-a4f3-9775fa44af2c"],
Cell[117056, 3418, 139, 1, 25, "Print", "ExpressionUUID" -> \
"638207b9-b80e-4842-8fb5-1cc99a3e1e01"],
Cell[117198, 3421, 123, 0, 25, "Print", "ExpressionUUID" -> \
"a9e3d98e-cf2f-4c3d-80dc-aef033b5f5d7"],
Cell[117324, 3423, 134, 0, 25, "Print", "ExpressionUUID" -> \
"1a59f15e-d1dc-4206-a29a-da73712c39f5"],
Cell[117461, 3425, 122, 0, 25, "Print", "ExpressionUUID" -> \
"c42c7f19-a943-4c30-9300-848a5c6f01d9"],
Cell[117586, 3427, 160, 2, 25, "Print", "ExpressionUUID" -> \
"9b98de6d-4c83-4fb5-a4f6-27dc94f73d2b"],
Cell[117749, 3431, 89, 0, 25, "Print", "ExpressionUUID" -> \
"bfbe4906-2b58-490d-82cf-b0c784420874"],
Cell[117841, 3433, 398, 10, 25, "Print", "ExpressionUUID" -> \
"065aadf6-a010-465f-aa63-b8b7a3641241"]
}, Open  ]]
}, Open  ]],
Cell[118266, 3447, 164, 3, 33, "Input", "ExpressionUUID" -> \
"24a60135-c2b7-449e-965a-cc239614b363"],
Cell[CellGroupData[{
Cell[118455, 3454, 186, 4, 33, "Input", "ExpressionUUID" -> \
"bb3afdbd-4236-4740-b37b-5e4b6f7a8267"],
Cell[CellGroupData[{
Cell[118666, 3462, 119, 0, 25, "Print", "ExpressionUUID" -> \
"b6a60d41-524e-48a0-8b65-5deca095bc6d"],
Cell[118788, 3464, 119, 0, 25, "Print", "ExpressionUUID" -> \
"11bb9aa9-524f-4557-bad1-e292bc61122f"],
Cell[118910, 3466, 119, 0, 25, "Print", "ExpressionUUID" -> \
"c34272ba-3ff4-4402-991f-5590f5037bac"],
Cell[119032, 3468, 106, 0, 25, "Print", "ExpressionUUID" -> \
"5677d373-a333-476b-9c38-cc0084b2a5e4"],
Cell[119141, 3470, 108, 0, 25, "Print", "ExpressionUUID" -> \
"2f70a3c0-e284-4f5f-99d8-9ef5494c22c6"],
Cell[119252, 3472, 111, 0, 25, "Print", "ExpressionUUID" -> \
"95a0bc1e-6880-401c-bc85-638e10b556b7"],
Cell[119366, 3474, 105, 0, 25, "Print", "ExpressionUUID" -> \
"a4477c8b-b881-478d-880c-9ebf0cba53de"],
Cell[119474, 3476, 89, 0, 25, "Print", "ExpressionUUID" -> \
"97bb52ed-0cc3-4402-864a-ba142c720956"],
Cell[119566, 3478, 408, 11, 25, "Print", "ExpressionUUID" -> \
"7c5eeba4-a778-401a-a2b0-7faaa209dd47"]
}, Open  ]]
}, Open  ]],
Cell[120001, 3493, 4961, 128, 644, "Input", "ExpressionUUID" -> \
"71a65982-6624-45a6-a03f-65942cb78837"],
Cell[124965, 3623, 6544, 197, 126, "Input", "ExpressionUUID" -> \
"c5d51b10-d4e9-4530-a194-bd4e8d346a41"],
Cell[CellGroupData[{
Cell[131534, 3824, 130, 1, 33, "Input", "ExpressionUUID" -> \
"5d8d6d37-0ed5-430a-b325-dde5c8322502"],
Cell[CellGroupData[{
Cell[131689, 3829, 114, 0, 25, "Print", "ExpressionUUID" -> \
"fab5b074-9943-4498-b401-51398582308b"],
Cell[131806, 3831, 125, 0, 25, "Print", "ExpressionUUID" -> \
"8d6f97ff-aa65-4f0c-bb86-697b0d825efd"],
Cell[131934, 3833, 115, 0, 25, "Print", "ExpressionUUID" -> \
"890c7cf0-8e77-46f6-b43b-7ef48a603869"],
Cell[132052, 3835, 125, 0, 25, "Print", "ExpressionUUID" -> \
"3aac65d5-1e4a-4ec1-a41f-961b6654c222"],
Cell[132180, 3837, 112, 0, 25, "Print", "ExpressionUUID" -> \
"0397cbbe-8d70-42db-8c50-29a73a88d834"],
Cell[132295, 3839, 125, 0, 25, "Print", "ExpressionUUID" -> \
"7232a70f-5b0e-44d1-9b83-05eba1139d22"],
Cell[132423, 3841, 275, 6, 25, "Print", "ExpressionUUID" -> \
"7eaf0516-600e-43ea-9ee1-ea73864c4c92"],
Cell[132701, 3849, 275, 6, 25, "Print", "ExpressionUUID" -> \
"fcbb7839-d679-4dff-84a0-6f86a876f22f"],
Cell[132979, 3857, 275, 6, 25, "Print", "ExpressionUUID" -> \
"179a4d8b-e592-49ed-8001-2bafa1da809b"],
Cell[133257, 3865, 275, 6, 25, "Print", "ExpressionUUID" -> \
"c54c7024-109b-4d29-895b-4ee703c35f9f"],
Cell[133535, 3873, 275, 6, 25, "Print", "ExpressionUUID" -> \
"2a10036c-f149-4914-9607-467bad091e3b"],
Cell[133813, 3881, 275, 6, 25, "Print", "ExpressionUUID" -> \
"6617f8f4-65d1-4a21-891d-68fd400dce83"],
Cell[134091, 3889, 277, 6, 25, "Print", "ExpressionUUID" -> \
"df63d6eb-c050-452b-abe9-2124c9123881"],
Cell[134371, 3897, 277, 6, 25, "Print", "ExpressionUUID" -> \
"4cbbd71f-28cb-4208-aa6c-3d1f633234e8"],
Cell[134651, 3905, 277, 6, 25, "Print", "ExpressionUUID" -> \
"47cc3912-f7aa-4703-b281-414bac9584ad"],
Cell[134931, 3913, 275, 6, 25, "Print", "ExpressionUUID" -> \
"35614a12-6d0c-4f9b-9f5b-e14b79099580"],
Cell[135209, 3921, 275, 6, 25, "Print", "ExpressionUUID" -> \
"8e2ba53f-7607-4e37-9486-0ec678aa6a8d"],
Cell[135487, 3929, 275, 6, 25, "Print", "ExpressionUUID" -> \
"673a3cb2-ae1e-46b2-a6eb-ce5d46362e9d"],
Cell[135765, 3937, 89, 0, 25, "Print", "ExpressionUUID" -> \
"e033af7f-6b21-454a-af2b-1d32b827123a"],
Cell[135857, 3939, 89, 0, 25, "Print", "ExpressionUUID" -> \
"26c11005-2381-47b6-bee6-104152f0d3f3"],
Cell[135949, 3941, 106, 0, 25, "Print", "ExpressionUUID" -> \
"d8c4642c-3fc1-447d-91fe-1434c5e46315"],
Cell[136058, 3943, 125, 0, 25, "Print", "ExpressionUUID" -> \
"98206ada-c855-4506-8e48-d531e835a985"],
Cell[136186, 3945, 89, 0, 25, "Print", "ExpressionUUID" -> \
"02b8574c-536f-419a-8c3b-7329c75f35b9"],
Cell[136278, 3947, 89, 0, 25, "Print", "ExpressionUUID" -> \
"789c7c71-71ef-4b13-880c-66ade23f1926"],
Cell[136370, 3949, 115, 0, 25, "Print", "ExpressionUUID" -> \
"bd06fe3a-77c3-4ea7-98f9-911e983d1643"],
Cell[136488, 3951, 125, 0, 25, "Print", "ExpressionUUID" -> \
"568ae949-0b1f-4c54-87a8-c54b20e6e3f5"],
Cell[136616, 3953, 277, 6, 25, "Print", "ExpressionUUID" -> \
"439d2c20-6911-4127-bb42-365a8d676d92"],
Cell[136896, 3961, 277, 6, 25, "Print", "ExpressionUUID" -> \
"1197fc82-2dd9-4aea-923e-a9fa04bc5636"],
Cell[137176, 3969, 275, 6, 25, "Print", "ExpressionUUID" -> \
"21307898-f4e0-431d-8a18-36b79e8d6d53"]
}, Open  ]]
}, Open  ]],
Cell[137478, 3979, 6537, 196, 126, "Input", "ExpressionUUID" -> \
"3aa84293-f8b0-46ee-8a08-afc42383877c"],
Cell[CellGroupData[{
Cell[144040, 4179, 110, 1, 33, "Input", "ExpressionUUID" -> \
"397456d5-0a92-494f-84ae-7273be63a48a"],
Cell[CellGroupData[{
Cell[144175, 4184, 141, 1, 25, "Print", "ExpressionUUID" -> \
"d4712507-03ff-492e-aaed-fd5eb08844b5"],
Cell[144319, 4187, 125, 0, 25, "Print", "ExpressionUUID" -> \
"a6a17f09-c948-4dd5-b3a1-cea4c1720389"],
Cell[144447, 4189, 111, 0, 25, "Print", "ExpressionUUID" -> \
"1ce0f016-874f-4924-81d7-09fab4d330ef"],
Cell[144561, 4191, 127, 0, 25, "Print", "ExpressionUUID" -> \
"a28273e9-219b-480b-9f08-0501fbb09a8d"],
Cell[144691, 4193, 122, 0, 25, "Print", "ExpressionUUID" -> \
"e13e0afa-d20c-4294-b7a7-961a3691435d"],
Cell[144816, 4195, 126, 0, 25, "Print", "ExpressionUUID" -> \
"e61b8771-8aca-4524-9fe7-060eda61ecb4"],
Cell[144945, 4197, 113, 0, 25, "Print", "ExpressionUUID" -> \
"92dcf549-cea7-4b98-9b58-8f920af40267"],
Cell[145061, 4199, 126, 0, 25, "Print", "ExpressionUUID" -> \
"a3435ec5-ccda-4a91-89f6-d230ff6a982e"],
Cell[145190, 4201, 129, 0, 25, "Print", "ExpressionUUID" -> \
"ce48bdd9-0234-48da-b0bc-c18f20803553"],
Cell[145322, 4203, 117, 0, 25, "Print", "ExpressionUUID" -> \
"c2eddc7b-6487-4e7f-8d27-d9ddc271c8b9"],
Cell[145442, 4205, 89, 0, 25, "Print", "ExpressionUUID" -> \
"c7d805d4-b09b-488f-8d33-cace1e509d0a"],
Cell[145534, 4207, 399, 11, 25, "Print", "ExpressionUUID" -> \
"6da5996e-0d9c-4b0d-a7bc-56b2e6c892a5"],
Cell[145936, 4220, 169, 2, 25, "Print", "ExpressionUUID" -> \
"44786108-f699-4252-8bbe-7addbb35b4dd"]
}, Open  ]]
}, Open  ]]
}
]
*)

